      SUBROUTINE HSICC(ZIN,GAMDATA,MAXGAM,ALPHAT)

C        modified D.C. Radford,  Oct 1996 - check for byte order
C            of data files, swap bytes automatically if necessary....

      REAL    GAMDATA(MAXGAM,10), ALPHAT(MAXGAM,8)
      REAL    ALFTAB(23, 10, 8), ALPHE(23, 10, 8), DATA(9)
      REAL    E(100), EK(100), ETAB(23,10), TCC(8), TCL(8)
      REAL    TCM(8), TLE(8), TME(8)
      INTEGER IDX, GAMMANUM, NETAB(10), SHTORE
      INTEGER TBLKEY, Z, ZIN, ZOLD, ZTAB

      LOGICAL       SKIP(10)
      LOGICAL       MOREG, SWAPBYTES
      CHARACTER*2   SHOLD, SHTAB, SSHTAB
      CHARACTER*200 FULLNAME

      COMMON /COM2/ E1, E2, NS, L, N, ALPHA(23), NP, EE(23)

      INCLUDE      'RECL_FACT.PAR'
      DATA          ZOLD /0/


      IDX=1
      GAMMANUM=0
      Z = ZIN
      IF (Z .EQ. -1) Z = ZOLD
      IF (Z .GT. 103 .OR. Z .LT. 14) RETURN
      IF (Z.EQ.ZOLD) GO TO 801

C        open icc table data files, readonly if possible...
      CALL GET_DIRECTORY('RADWARE_ICC_LOC',FULLNAME,IOFFSET)
      FULLNAME(IOFFSET:) = 'iccndx.dat'
      CALL OPEN_READONLY(12, FULLNAME, RECL_FACT, IERR)
      IF (IERR.NE.0) THEN
         WRITE(6,100)
         CALL EXIT
      ENDIF
      FULLNAME(IOFFSET:) = 'icctbl.dat'
      CALL OPEN_READONLY(11, FULLNAME, 11*RECL_FACT, IERR)
      IF (IERR.NE.0) THEN
         WRITE(6,100)
         CALL EXIT
      ENDIF
100   FORMAT(
     +'  -- Check that the environment variable or logical name'/
     +'     RADWARE_ICC_LOC is properly defined, and that the files'/
     +'     iccndx.dat and icctbl.dat exist in the directory'/
     +'     to which it points.'/)

C        check to see if files have wrong byte-order....
      READ(12,REC=50) TBLKEY
C***      write(6,*) tblkey
      IF (TBLKEY.GT.10000 .OR. TBLKEY.LT.0) THEN
         SWAPBYTES = .TRUE.
      ELSE
         SWAPBYTES = .FALSE.
      ENDIF

C-INITIALIZE READ AND CALCULATIONAL VARIABLES

      DO J = 1, 10
         NETAB(J) = 0
         DO I = 1, 23
            ETAB(I, J) = 0.0
            DO K = 1, 8
               ALFTAB(I, J, K) = 0.0
               ALPHE(I, J, K) = 0.0
            ENDDO
         ENDDO
      ENDDO
      DO I = 1, 23
         ALPHA(I) = 0.0
         EE(I) = 0.0
      ENDDO
      DO I = 1, 100
         E(I) = 0.0
      ENDDO

      N = 0
      SHOLD =' '
      NE = 0
      SHTORE = 701

      READ(12,REC=Z) TBLKEY
      IF (SWAPBYTES) CALL SWAP_BYTES_I(TBLKEY)
      IF (TBLKEY .EQ. 0) RETURN
      IE = 0

C        read conversion coeff. tables from icctbl.dat....

7     READ(11,REC=TBLKEY) ZTAB, SHTAB, DATA
      IF (SWAPBYTES) THEN
         CALL SWAP_BYTES_I(ZTAB)
         DO I = 1, 9
            CALL SWAP_BYTES_R(DATA(I))
         ENDDO
      ENDIF
      TBLKEY=TBLKEY+1
C-EXIT FROM FILE READ LOOP WHEN TABLE VALUES FOR GIVEN Z EXHAUSTED
C  GT of next statement changed to NE for IPC
      IF (ZTAB .NE. Z) GOTO 801
      IF (SHOLD .NE. SHTAB) GOTO 8
      if (shtore.eq.701) then
         go to 701
      elseif (shtore.eq.705) then
         go to 705
      endif

  701 ISH = 1
      GOTO 7041

  704 ISH = 1
 7040 SSHTAB=SHTAB
      READ(SSHTAB(2:2),'(I1)') ISHELL
      ISH = ISHELL + ISH
 7041 SHTORE = 705

  705 IE = IE + 1
C-ETAB IS TABLE GAMMA ENERGY, ALFTAB IS TABULAR ICC FOR THE 8 MULTIPO
      ETAB(IE, ISH) = DATA(1)
      DO 7050 I = 1, 8
          ALFTAB(IE, ISH, I) = DATA(I + 1)
 7050 CONTINUE
      IF (TBLKEY .GT. 13004) GOTO 801
      GOTO 7

    8 SHOLD = SHTAB
      IF (IE .NE. 0) NETAB(ISH) = IE
      IE = 0
      SSHTAB=SHTAB
      IF(SSHTAB(1:1).EQ.'K') GO TO 701
      IF(SSHTAB(1:1).EQ.'L') GO TO 704
      IF(SSHTAB(1:1).EQ.'M') THEN
          ISH=4
          GO TO 7040
      ENDIF
      IF(SSHTAB(1:1).EQ.'N') THEN
          ISH=10
          GO TO 7041
      ENDIF

C        finished reading conversion coeff. tables from icctbl.dat....
C        now assemble gamma energies for conv. coef. calculations....
C        can handle 100 gammas at a time....

801   ZOLD = Z
      IF (IE .NE. 0) NETAB(ISH) = IE

50    NE = 0
      MOREG = .TRUE.
      DO 51 I = IDX,IDX+99

C%here changed dum1 to energy passed into subroutine
         IF (GAMDATA(I,1) .EQ. 0.0) THEN
            MOREG= .FALSE.
C-              IF NO GAMMAS REMAINING IN DATA SET, RETURN
            IF (NE .EQ. 0) RETURN
            GO TO 6001
         ENDIF
         E(I-IDX+1)=GAMDATA(I,1)
         IF (GAMDATA(I,1) .NE. 0) NE=I-IDX+1
51    CONTINUE
      IDX=IDX+100

C         now calculate conv. coeffs. for 23 gammas at a time....

 6001 NP = 23
      IF (NE .LT. 24) NP = NE
      NPOLD = NP
      DO 61 I = 1, NP
          EK(I) = E(I)
          EE(I) = EK(I)
   61 CONTINUE
      N = NETAB(1)
      IF (N .EQ. 0) GOTO 70
      E1 = ETAB(1, 1)
      E2 = E1
      NS = 1
      IF (Z .LT. 30) NS = 5
      K = 1
      CALL ILOOP
      DO 68 I = 1, 8
          L = I
          IF (L .GT. 4) L = I - 4
          DO 66 J = 1, N
              ALPHA(J) = ALFTAB(J, 1, I)
   66         CONTINUE
          CALL FIT
C-RESET FOR NEXT CALL TO 'FIT'
          E1 = ETAB(1, 1)
          DO 67 J = 1, NPOLD
              IF (EK(J) .GE. E1) GOTO 665
              DO 6601 ME = 1, NPOLD-J
                  M = NPOLD + 1 - ME
                  IF (M .GT. 1) ALPHA(M) = ALPHA(M - 1)
 6601             CONTINUE
              ALPHA(J) = -1.
  665         ALPHE(J, 1, I) = ALPHA(J)
   67         CONTINUE
   68     CONTINUE
      NP = NPOLD
      DO M = 1, NP
         EE(M) = EK(M)
      ENDDO

C-GET L-SUBSHELL ICC

   70 NS = 2
      IF (Z .LT. 30) NS = 5
      DO K = 2, 4
         N = NETAB(K)
         IF (N .EQ. 0) GOTO 75
         E1 = ETAB(1, K)
         CALL ILOOP

         DO I = 1, 8
            E2 = ETAB(1, 3)
            L = I
            IF (L .GT. 4) L = I - 4
            DO J = 1, N
               ALPHA(J) = ALFTAB(J, K, I)
            ENDDO
            CALL FIT
            E1 = ETAB(1, K)
            DO J = 1, NPOLD
               IF (EK(J) .GE. E1) GOTO 715
               DO ME = 1, NPOLD-J
                  M = NPOLD + 1 - ME
                  IF (M .GT. 1) ALPHA(M) = ALPHA(M - 1)
               ENDDO
               ALPHA(J) = -1.0
  715          ALPHE(J, K, I) = ALPHA(J)
            ENDDO
         ENDDO
         NP = NPOLD
         DO M = 1, NP
            EE(M) = EK(M)
         ENDDO
      ENDDO

C-GET M-SUBSHELL ICC (LOOP ENDS AT 79)

   75 NS = 3
      DO K = 5, 9
         N = NETAB(K)
         IF (N .EQ. 0) GOTO 80
         E1 = ETAB(1, K)
         CALL ILOOP

         DO I = 1, 8
            E2 = ETAB(1, 9)
            L = I
            IF (L .GT. 4) L = I - 4
            DO J = 1, N
               ALPHA(J) = ALFTAB(J, K, I)
            ENDDO
            CALL FIT
            E1 = ETAB(1, K)
            DO J = 1, NPOLD
               IF (EK(J) .GE. E1) GOTO 765
               DO ME = 1, NPOLD-J
                  M = NPOLD + 1 - ME
                  IF (M .GT. 1) ALPHA(M) = ALPHA(M - 1)
               ENDDO
               ALPHA(J) = -1.0
  765          ALPHE(J, K, I) = ALPHA(J)
            ENDDO
         ENDDO
         NP = NPOLD
         DO M = 1, NP
            EE(M) = EK(M)
         ENDDO
      ENDDO

C-GET N+O+... SHELL ICC (LOOP ENDS AT 84)

   80 N = NETAB(10)
      IF (N .EQ. 0) GOTO 85
      NS = 4
      E1 = ETAB(1, 10)
      K = 10

      CALL ILOOP

      DO I = 1, 8
         L = I
         IF (L .GT. 4) L = I - 4
         DO J = 1, N
            ALPHA(J) = ALFTAB(J, K, I)
         ENDDO
         CALL FIT
         E1 = ETAB(1, K)
         DO J = 1, NPOLD
            IF (EK(J) .GE. E1) GOTO 815
            DO ME = 1, NPOLD-J
               M = NPOLD + 1 - ME
               IF (M .GT. 1) ALPHA(M) = ALPHA(M - 1)
            ENDDO
            ALPHA(J) = -1.0
  815       ALPHE(J, K, I) = ALPHA(J)
         ENDDO
      ENDDO
      NP = NPOLD
      DO M = 1, NP
          EE(M) = EK(M)
      ENDDO

C-OUTPUT LOOP

   85 DO 90 I = 1, NP
C-INITIALIZE OUTPUT VARIABLES
         DO KK = 1, 8
            TCL(KK) = 0.0
            TLE(KK) = 0.0
            TCM(KK) = 0.0
            TME(KK) = 0.0
            TCC(KK) = 0.0
         ENDDO
         DO JJ = 1, 10
            SKIP(JJ) = .FALSE.
         ENDDO

C-IF GAMMA ENERGY < BINDING ENERGY, ICC = 0

         DO K = 1, 10
            IF (K .EQ. 10) GOTO 8511
            IF (Z .LT. 30) GOTO 8511
            IF ((ETAB(1, K) - 1.0) .LE. EK(I)) GOTO 8511
               DO IGF = 1, 8
                  ALPHE(I, K, IGF) = 0.0
               ENDDO
 8511       IF (ALPHE(I, K, 1) .LT. 0.0) SKIP(K) = .TRUE.
         ENDDO
C-DRAGOUN ET AL LIST NO ICC FOR Z < 37
         IF (Z .LT. 37) SKIP(10) = .TRUE.
         IF (Z .LT. 30) SKIP(5) = .TRUE.


   86    DO 8619 N = 1,8
C   TOTAL-L
C   TOTAL L IS CALCULATED THOUGH SOME OF THE L'S SHOULD BE SKIPPED

            DO K = 2, 4
               IF (.NOT. SKIP(K)) TCL(N) = TCL(N) + ALPHE(I, K, N)
            ENDDO
            IF (.NOT.SKIP(1)) TLE(N) = ALPHE(I, 1, N) + 1.33 * TCL(N)

C   TOTAL-M
            DO K = 5, 9
               IF (.NOT.SKIP(K)) TCM(N) = TCM(N) + ALPHE(I, K, N)
            ENDDO

C  Do not CALCULATE TOTAL if L's and M's are to skip

            DO KK=1,9
                  IF(SKIP(KK)) GO TO 8619
            ENDDO
            TME(N)=ALPHE(I,1,N) + TCL(N)+1.33*TCM(N)

C   TO AVOID TME VALUE SET TO -1. WHEN EVERYHING ENEGY OUTSIDE RANGE

            IF(TME(N).LT.0.) TME(N)=0.
            IF (.NOT.SKIP(10))
     1            TCC(N) = ALPHE(I, 1, N) + TCL(N) + TCM(N) +
     +                ALPHE(I, 10, N)
 8619    CONTINUE

         K = 1
         GAMMANUM=GAMMANUM+1

         DO J=1,8
            ALPHAT(GAMMANUM,J)=TLE(J)
         ENDDO

         IF (TME(1) .NE. 0.0) THEN
            DO J=1,8
               ALPHAT(GAMMANUM,J)=TME(J)
            ENDDO
         ENDIF
         IF (TCC(1) .NE. 0.0) THEN
            DO J=1,8
               ALPHAT(GAMMANUM,J)=TCC(J)
            ENDDO
         ENDIF
 
   90 CONTINUE

      IF (NE .LT. (NP+1))  GOTO 92

C-REPLACE LAST 23 GAMMA DATA FIT WITH NEXT 23 DATA TO BE FIT

          DO 91 K = NP+1, NE
              KNP = K - NP
              E(KNP) = E(K)
              EK(KNP) = EK(K)
   91     CONTINUE
          NE = NE - NP
          GOTO 6001

   92 CONTINUE
      IF (MOREG) GOTO 50

      RETURN
      END


      SUBROUTINE SWAP_BYTES_I(IN)

      INTEGER*4    IN, IWORK
      CHARACTER*1  CWORK(4), CSAVE
      EQUIVALENCE (IWORK,CWORK)

      IWORK = IN
      CSAVE = CWORK(1)
      CWORK(1) = CWORK(4)
      CWORK(4) = CSAVE
      CSAVE = CWORK(2)
      CWORK(2) = CWORK(3)
      CWORK(3) = CSAVE
      IN = IWORK

      RETURN
      END


      SUBROUTINE SWAP_BYTES_R(IN)

      REAL*4       IN, RWORK
      CHARACTER*1  CWORK(4), CSAVE
      EQUIVALENCE (RWORK,CWORK)

      RWORK = IN
      CSAVE = CWORK(1)
      CWORK(1) = CWORK(4)
      CWORK(4) = CSAVE
      CSAVE = CWORK(2)
      CWORK(2) = CWORK(3)
      CWORK(3) = CSAVE
      IN = RWORK

      RETURN
      END


      BLOCK DATA
      REAL A(23)
      REAL B(4)
      REAL C(23)
      REAL D(4, 23)
      REAL E(23)
      REAL F(23)
      REAL H(23)
      REAL S(23)
      REAL T(23)
      REAL X(23)
      REAL Y(23)
      COMMON /COM1/ A, B, C, D, E, F, H, S, T, X, Y

      REAL    E1
      REAL    E2
      INTEGER NS
      INTEGER L
      INTEGER N
      REAL    ALPHA(23)
      INTEGER NP
      REAL    EE(23)
      COMMON /COM2/ E1, E2, NS, L, N, ALPHA, NP, EE

      DATA A, B, C, D, E, F, H, S, T, X, Y /303 * 0.0/
      DATA E1, E2, ALPHA, EE /48 * 0.0/
      DATA NS, L, N, NP / 4 * 0/
      END


      SUBROUTINE FIT

      COMMON /COM1/ A(23), B(4), C(23), D(4, 23), E(23), F(23), H(23),
     +    S(23), T(23), X(23), Y(23)
      COMMON /COM2/ E1, E2, NS, L, N, ALPHA(23), NP, EE(23)

      REAL ERG(23, 5), EN(23)
      DATA ERG/
     A       1.0,    1.7,    3.0,    6.2,   10.0,   14.0,   20.0,
     B      28.0,   40.0,   53.0,   70.0,   83.0,  100.0,  123.0,
     C     150.0,  215.0,  300.0,  390.0,  500.0,  730.0, 1000.0,
     D    1250.0, 1500.0,
     E       1.0,    1.7,    3.0,    6.2,   10.0,   14.0,   20.0,
     F      28.0,   40.0,   53.0,   70.0,   83.0,  100.0,  123.0,
     G     150.0,  215.0,  300.0,  390.0,  500.0,  730.0, 1000.0,
     H    1500.0,    0.0,
     I       1.0,    2.0,    4.0,    8.0,   15.0,   25.0,   40.0,
     J      52.0,   70.0,  103.0,  150.0,  280.0,  500.0,    0.0,
     K       9*      0.0,
     L      50.0,   70.0,  100.0,  150.0,  200.0,  500.0,    0.0,
     M      16*      0.0,
     N      15.0,   17.0,   20.0,   25.0,   32.0,   40.0,   50.0,
     O      65.0,   80.0,  100.0,  120.0,  150.0,  200.0,  300.0,
     P     450.0,  650.0, 1000.0, 2000.0, 6000.0,    4*      0.0/

C     ALL ENTRIES GIVEN FOR A PARTICULAR CASE MUST BE USED
C     E1 = LOWEST TABULATED ENERGY OF SUBSHELL TO BE INTERPOLATED, EXCEP03 00250
C     *TOTAL* L- OR M-SHELLS IN WHICH CASE E1=-1.0  WE DO NOT INTERPOLA
C     IN TOTAL L OR M SHELL , WE INTERPOLATE IN SUBSHELLS AND THEN
C     SUM THE SEPARATE SUBSHELL VALUES
C     E2 = LOWEST TABULATED ENERGY OF THE K, L2, M5 SUBSHELLS FOR THE
C     INTERPOLATION IN THE K, L, M SHELLS, RESPECTIVELY
C     NS = 1, 2, 3 FOR THE K, L, M SHELLS, RESPECTIVELY
C     L = MULTIPOLE ORDER FOR THE CASE TO BE INTERPOLATED
C     N = NUMBER OF VALUES GIVEN IN EACH CASE IN THE TABLE
C     ALPHA = LIST OF CONVERSION COEFFICIENTS FROM THE TABLE
C     NP = NUMBER OF CONVERSION COEFFICIENTS TO BE INTERPOLATED, MUST BE03 00350
C     THAN 24
C     EE = LIST OF GAMMA RAY ENERGIES OF THE VALUES TO BE DETERMINED


      IF (NS .GE. 4) GOTO 21

      IF (NS .EQ. 1) E2 = E1
      E1 = -E1 + 1.
      E2 = -E2 + 1.
      NE2 = -E2 + 0.501
      NN = N
      IF (NN .LT. 6) GOTO 10
          DO 15 I = 6, NN
              M = ERG(I, NS) + 0.01
              J = M + NE2
              IF (.NOT. (M .LT. 150)) GOTO 11
                  J = (10 * J + 5) / 10
                  GOTO 14
   11         IF (.NOT. (M .LT. 390)) GOTO 12
                  J = 5 * ((10 * J + 25) / 50)
                  GOTO 14
   12         IF (.NOT. (M .LT. 1000)) GOTO 13
                  J = 10 * ((J + 5) / 10)
                  GOTO 14
C             (M .GE. 1000)
   13             J = 50 * ((J + 25) / 50)

   14         EN(I) = J
              C(I) = EN(I) + E1
   15         CONTINUE

   10 DO 16 I = 1, 5
          C(I) = ERG(I, NS)
          EN(I) = ERG(I, NS) - E1
   16     CONTINUE
      DO 17 I = 1, N
          C(I) = ALOG(SQRT((1021.952 + C(I)) * C(I)))
   17     CONTINUE
      DO 18 I = 1, NP
          W = EE(I) + E1
          IF (W .LT. 0) GOTO 18
              X(I) = ALOG(SQRT((1021.952 + W) * W))
   18     CONTINUE
      M = 2 * L + 1
      DO 19 I = 1, N
          A(I) = ALOG(ALPHA(I) * EN(I) ** M)
   19     CONTINUE
      CALL SPLINE(N, NP)
      DO 20 I = 1, NP

          ALPHA(I) = EXP(Y(I)) / EE(I) ** M
   20     CONTINUE
      GOTO 33

C-NEW SECTION TO INTERPOLATE ICC FROM TABLES OTHER THAN HAGER-SELTZER
C-NS=4 IS THE N+O+... FROM DRAGOUN ET AL.
C-NS=5 IS THE K,L FOR Z < 30 FROM BAND ET AL.

   21 DO 22 I = 1, N
          EN(I) = ERG(I, NS)
          C(I) = ERG(I, NS)
          C(I) = ALOG(SQRT((1021.952 + C(I)) * C(I)))
   22     CONTINUE
      DO 23 I = 1, NP
          IF (EE(I) .LT. E1) GOTO 23
              X(I) = ALOG(SQRT((1021.952 + EE(I)) * EE(I)))
   23     CONTINUE
      M = 2 * L + 1
      DO 24 I = 1, N
          A(I) = ALOG(ALPHA(I) * EN(I) **M)
   24     CONTINUE
      CALL SPLINE(N, NP)
      DO 25 I = 1, NP
          ALPHA(I) = EXP(Y(I)) / EE(I) ** M
   25     CONTINUE

   33 L1 = 0
      M1 = N + L1
      DO 37 I = 1, NP
          IF ((EE(I) .LT. EN(L1 + 1)) .OR. (EE(I) .GT. EN(M1)))
     +        ALPHA(I) = -1.
   37     CONTINUE
      RETURN
      END


      SUBROUTINE SPLINE(N, NP)
      COMMON /COM1/ A(23), B(4), C(23), D(4, 23), E(23), F(23), H(23),
     +    S(23), T(23), X(23), Y(23)

      M = N - 1
      DO 7 I = 1, M
          E(I) = C(I + 1) - C(I)
          F(I) = A(I + 1) - A(I)
    7     CONTINUE
      MS = N - 2
      DO 8 I = 1, MS
          D(1, I) = E(I + 1)
          D(2, I) = 2. * (E(I) + E(I + 1))
          D(3, I) = E(I)
          D(4, I)= 3. * (E(I + 1) * F(I) / E(I) + E(I) * F(I + 1) /
     +        E(I + 1))
    8     CONTINUE
      S(1) = -1.
      T(1) = 2. * F(1) / E(1)
      DO 9 I = 2, M
          L = I - 1
          S(I) = -(D(1, L) + D(2, L) * S(L)) / (D(3, L) * S(L))
          T(I) = (-T(L) * (D(2, L) + D(3, L) * S(I)) + D(4, L)) /
     +        D(3, L)
    9     CONTINUE
      AA = 2. * F(M) / E(M)
      H(N) = (T(M) + AA * S(M)) / (S(M) + 1.)
      DO 10 I = 1, M
          K = N - I
          H(K) = (H(K + 1) - T(K)) / S(K)
   10     CONTINUE
      DO 12 I = 1, NP
          DO 13 K = 1, M
              IF (X(I) .LT. C(K + 1)) GOTO 14
   13         CONTINUE
          K = K - 1
   14     K1 = K
          Z = (C(K1 + 1) - C(K1)) / 2.
          B(3) = (H(K1 + 1) - H(K1)) / (4. * Z)
          B(4) = .25 * ((H(K1 + 1) + H(K1)) * Z - A(K1 + 1) + A(K1)) /
     +        Z ** 3
          B(1) = (A(K1 + 1) + A(K1) - 2. * B(3) * Z ** 2) / 2.
          B(2) = (H(K1 + 1) + H(K1) - 6. * B(4) * Z ** 2) / 2.
          ZP = X(I) - (C(K1 + 1) + C(K1)) / 2.
          Y(I) = B(1) + ZP * (B(2) + ZP * (B(3) + ZP * B(4)))
   12     CONTINUE
      RETURN
      END


      SUBROUTINE ILOOP
      COMMON /COM2/ E1, E2, NS, L, N, ALPHA(23), NP, EE(23)

      I = 1
   10 IF (I .GT. NP) RETURN
          IF (EE(I) .GE. E1) GOTO 30
          IF (NP .LE. 1) GOTO 30
          NP = NP - 1
          DO 20 M = I, NP
               EE(M) = EE(M + 1)
   20          CONTINUE
          I = I - 1
   30 I = I + 1
      GOTO 10
      END
