
C=======================================================================

      SUBROUTINE READ_ASCII_GLS

      INCLUDE         'GLS.CMN'
      CHARACTER*80    JUNK
      CHARACTER*8     JPI
      CHARACTER*6     KAY
      CHARACTER*2     EOL


C           read comments (first five lines of file) ....
      WRITE (IW,*) 'Level Scheme File header:'
      DO J = 1, 5
         READ (25,50) JUNK
         WRITE (IW,*) JUNK
      ENDDO

      READ (25,50) JUNK
      IF (JUNK.NE.' ASCII GLS file format version 1.0') GO TO 900

C           read data....
      READ (25,55,ERR=900) ATOMIC_NO, LEVEL, GAMMA, NBANDS, NTLABEL,
     +               CSX, CSY, ASPECT_RATIO, MAX_TANGENT, MAX_DIST,
     +               DEFAULT_WIDTH, DEFAULT_SEP, ARROW_WIDTH,
     +               ARROW_LENGTH, ARROW_BREAK, LEVEL_BREAK,
     +               L_CSX, L_CSY, L_E_CSX, L_E_CSY, G_CSX, G_CSY
      READ (25,50) JUNK
      READ (25,50) JUNK
      DO J = 1, LEVEL
         READ (25,65,ERR=900) (LEVDATA(J,K),K=1,2), JPI, KAY,
     +               BAND(J), LEVEL_FLAG(J), L_LABEL_FLAG(J),
     +               L_E_LABEL_FLAG(J), EOL

         IF (EOL.EQ.' &') THEN
            READ (25,66,ERR=900) L_LABEL_DX(J), L_LABEL_DY(J),
     +               L_E_LABEL_DX(J), L_E_LABEL_DY(J),
     +               LEVEL_DX(1,J), LEVEL_DX(2,J)
         ELSE
            L_LABEL_DX(J)   = 0.0
            L_LABEL_DY(J)   = 0.0
            L_E_LABEL_DX(J) = 0.0
            L_E_LABEL_DY(J) = 0.0
            LEVEL_DX(1,J)   = 0.0
            LEVEL_DX(2,J)   = 0.0
         ENDIF
         IF (JPI(6:7).EQ.'/2') THEN
            READ(JPI,'(I5)') J1
            LEVDATA(J,3) = FLOAT(J1)/2.0
         ELSE
            READ(JPI,'(I7)') J1
            LEVDATA(J,3) = FLOAT(J1)
         ENDIF
         IF (JPI(8:8).EQ.'-') THEN
            LEVDATA(J,4) = -1.0
         ELSE
            LEVDATA(J,4) = 1.0
         ENDIF
         IF (KAY(5:6).EQ.'/2') THEN
            READ(KAY,'(I4)') J1
            LEVDATA(J,5) = FLOAT(J1)/2.0
         ELSE
            READ(KAY,'(I6)') J1
            LEVDATA(J,5) = FLOAT(J1)
         ENDIF
      ENDDO

      READ (25,50) JUNK
      DO J = 1, NBANDS
         READ (25,75,ERR=900) BAND_NAME(J), BAND_X0(J), BAND_NX(J),
     +               B_LABEL_DX(J), B_LABEL_DY(J),
     +               B_E_LABEL_DX(J), B_E_LABEL_DY(J)
      ENDDO

      READ (25,50) JUNK
      READ (25,50) JUNK
      READ (25,50) JUNK
      DO J = 1, GAMMA
         READ (25,85,ERR=900) GAMDATA(J,1), GAMDATA(J,2), GAML(J), J1,
     +               (GAMID(J,K),K=1,2), GAMDATA(J,3), GAMDATA(J,4), EOL
         GAMN(J) = J1
         IF (EOL.EQ.' &') THEN
            READ (25,86,ERR=900)
     +               GAMDATA(J,6), GAMDATA(J,8), GAMDATA(J,5), 
     +               GAMDATA(J,10), GAMDATA(J,7), GAMDATA(J,9), EOL
         ELSE
            DO K = 5, 10
               GAMDATA(J,K) = 0.0
            ENDDO
            CALL CALC_ALPHA(J)
         ENDIF
         IF (EOL.EQ.' &') THEN
            READ (25,87,ERR=900)
     +               GAMMA_X1(J), GAMMA_X2(J),
     +               G_LABEL_DX(J), G_LABEL_DY(J),
     +               GAMMA_FLAG(J), G_LABEL_FLAG(J)
         ELSE
            GAMMA_X1(J) = 0.0
            GAMMA_X2(J) = 0.0
            G_LABEL_DX(J) = 0.0
            G_LABEL_DY(J) = 0.0
            GAMMA_FLAG(J) = 0
            G_LABEL_FLAG(J) = 0
         ENDIF
      ENDDO

      IF (NTLABEL.GT.0) READ (25,50) JUNK
      IF (NTLABEL.GT.0) READ (25,50) JUNK
      DO J = 1, NTLABEL
         READ (25,95,ERR=900) TLABEL(J), TLABEL_NC(J),
     +               TCSX(J), TCSY(J), TLABEL_X(J), TLABEL_Y(J)
      ENDDO

      CLOSE(25)
      RETURN

50    FORMAT(A)
55    FORMAT(/I5,4I8,3F10.2//F15.6,5F11.2//2F12.2,6F9.2)
65    FORMAT(6X,F11.3,F8.3,A8,A6,I6,3I10,A2)
66    FORMAT(2X,6F10.2)
75    FORMAT(5X,1X,A8,6F10.2)
85    FORMAT(6X,F11.3,F8.3,3X,A,I2,2I6,F11.4,F8.4,A2)
86    FORMAT(2X,3(E13.5,E10.3),A2)
87    FORMAT(2X,4F10.2,2I10)
95    FORMAT(5X,2X,A40,I8/2X,4F10.2)

C         error messages....
900   WRITE(IW,*) 'ERROR - cannot read ASCII gls file.'
      RETURN
      END
