C=================================================================
      SUBROUTINE WAGS(OUT,mode)

c  Writes AGS file using common block data

      PARAMETER    (MAXLEV=600,MAXGAM=1500,MAXEMIT=21)
      PARAMETER    (MAXBAND=200)
      implicit none

c------------------gls.cmn--------------------------------------
C max. no. of levels, gammas:

C level definition-----------------
C levname=name of level
C levid=id number related to level spin
C levdata= 1)energy
C          2)energy error
C          3)spin
C          4)parity
C          5)K
      CHARACTER*8   LEVNAME(MAXLEV)
      INTEGER       LEVID(MAXLEV)
      REAL          LEVDATA(MAXLEV,5)

C gamma definition------------------------
C gamid= 1)index pointer to initial level
C        2)index pointer to final level
C gamdata= 1)energy
C          2)energy error
C          3)intensity
C          4)intensity error
C          5)BR (branching ratio)
C          6)A (conversion coeffient)
C          7)D (mixing ratio)
C          8)delta A
C          9)delta D
C         10)delta BR
      INTEGER       GAMID(MAXGAM,2)
      CHARACTER     GAML(MAXGAM)
      REAL          GAMDATA(MAXGAM,10),GAMN(MAXGAM)

      INTEGER       LEVEL,GAMMA

      COMMON /L/ LEVNAME,LEVID,LEVDATA,LEVEL,
     +           GAMID,GAML,GAMDATA,GAMN,GAMMA

      INTEGER       ATOMIC_NO, NBANDS, BAND(MAXLEV)
      REAL          GAMMA_X1(MAXGAM), GAMMA_X2(MAXGAM)
      REAL          BAND_X0(MAXBAND), BAND_NX(MAXBAND)
      CHARACTER*8   BAND_NAME(MAXBAND)
      COMMON /GLS1/ ATOMIC_NO, GAMMA_X1, GAMMA_X2,
     +              NBANDS, BAND_NAME, BAND_X0, BAND_NX, BAND

      INTEGER       LEVEMIT(MAXLEV,MAXEMIT)
      COMMON /LEVEMIT/ LEVEMIT

C           all figure distance units are in keV....
C           gamma arrow widths = intensity*aspect_ratio (keV)...

      REAL             X0, HIX, Y0, HIY, TX0, THIX, TY0, THIY
      REAL             CSX, CSY, ASPECT_RATIO, MAX_TANGENT, MAX_DIST
      REAL             DEFAULT_WIDTH, DEFAULT_SEP
      REAL             ARROW_WIDTH, ARROW_LENGTH
      REAL             GAMMA_X(10,MAXGAM), GAMMA_Y(10,MAXGAM)
      INTEGER          GAMMA_NP(MAXGAM)
      CHARACTER*10     G_LABEL(MAXGAM)
      REAL             G_LABEL_X(MAXGAM), G_LABEL_Y(MAXGAM)
      INTEGER          G_LABEL_NC(MAXGAM)
      REAL             LEVEL_X(4,MAXLEV), LEVEL_Y(MAXLEV)
      REAL             L_LABEL_X(MAXLEV), L_LABEL_Y(MAXLEV)
      CHARACTER*12     L_LABEL(MAXLEV)
      INTEGER          L_LABEL_NC(MAXLEV)
      LOGICAL          B_LABEL_L(MAXBAND)
      REAL             B_LABEL_DX(MAXBAND)
      REAL             G_LABEL_DX(MAXGAM), G_LABEL_DY(MAXGAM)
      REAL             L_LABEL_DX(MAXLEV)
      COMMON /GLS_FIG/ X0, HIX, Y0, HIY, TX0, THIX, TY0, THIY,
     +                 CSX, CSY, ASPECT_RATIO, MAX_TANGENT, MAX_DIST,
     +                 DEFAULT_WIDTH, DEFAULT_SEP,
     +                 ARROW_WIDTH, ARROW_LENGTH,
     +                 GAMMA_X, GAMMA_Y, GAMMA_NP,
     +                 G_LABEL, G_LABEL_X, G_LABEL_Y, G_LABEL_NC,
     +                 LEVEL_X, LEVEL_Y,
     +                 L_LABEL, L_LABEL_X, L_LABEL_Y, L_LABEL_NC,
     +                 B_LABEL_L, B_LABEL_DX, G_LABEL_DX, G_LABEL_DY,
     +                 L_LABEL_DX

C                    break distance in kev for tentative gammas, levels....
      REAL             ARROW_BREAK, LEVEL_BREAK
C                    character sizes for j(pi), level energy, gamma energy....
      REAL             L_CSX, L_CSY, L_E_CSX, L_E_CSY, G_CSX, G_CSY
C                    flags for tentative gammas, gamma energies....
      INTEGER          GAMMA_FLAG(MAXGAM), G_LABEL_FLAG(MAXGAM)
C                    flags for tentative levels....
      INTEGER          LEVEL_FLAG(MAXLEV)
C                    flags for tentative j(pi)'s, level energies....
      INTEGER          L_LABEL_FLAG(MAXLEV), L_E_LABEL_FLAG(MAXLEV)
      CHARACTER*10     L_E_LABEL(MAXLEV)
      INTEGER          L_E_LABEL_NC(MAXLEV)
C                    horizontal offsets for stretching/shrinking levels....
      REAL             LEVEL_DX(2,MAXLEV)
C                    vertical offset for j(pi)....
      REAL             L_LABEL_DY(MAXLEV)
C                    horiz., vert. offsets, positions for level energies....
      REAL             L_E_LABEL_DX(MAXLEV), L_E_LABEL_DY(MAXLEV)
      REAL             L_E_LABEL_X(MAXLEV), L_E_LABEL_Y(MAXLEV)
C                    vertical offset for j(pi)
      REAL             B_LABEL_DY(MAXBAND)
C                    horizontal, vertical offsets for level energies....
      REAL             B_E_LABEL_DX(MAXBAND), B_E_LABEL_DY(MAXBAND)
C                    general purpose text labels....
      INTEGER          NTLABEL, TLABEL_NC(100)
      CHARACTER*40     TLABEL(100)
      REAL             TCSX(100), TCSY(100)
      REAL             TLABEL_X(100), TLABEL_Y(100)

      COMMON /GLS2/    ARROW_BREAK, LEVEL_BREAK, L_CSX, L_CSY, L_E_CSX,
     +                 L_E_CSY, G_CSX, G_CSY, GAMMA_FLAG, G_LABEL_FLAG,
     +                 LEVEL_FLAG, L_LABEL_FLAG, L_E_LABEL_FLAG,
     +                 L_E_LABEL, L_E_LABEL_NC, LEVEL_DX, L_LABEL_DY,
     +                 L_E_LABEL_DX, L_E_LABEL_DY, L_E_LABEL_X,
     +                 L_E_LABEL_Y, B_LABEL_DY, B_E_LABEL_DX, 
     +                 B_E_LABEL_DY, NTLABEL, TLABEL_NC, TLABEL, 
     +                 TCSX, TCSY, TLABEL_X, TLABEL_Y

c---------------------------------------------------------------
      CHARACTER*8     JPI
      CHARACTER*6     KAY
      INTEGER         J1, J2, LEVEL_LOOKUP(MAXLEV), JBAND, STEP
      REAL            BAND_K,CONVT(MAXGAM,8),DELSQ

      logical done

      character CH
      integer   OUT,i,ii,j,jj,mode,count,itent,IDeltaS,K
      real      r,ad,DeltaS,DeltaE,DDeltaE

      INCLUDE 'fconv.inc'

      done=.false.

      if(.not.done.or.mode.eq.7) then
c        Write file history
         WRITE(out,114) '** NUCID = ',NUCID,'  A = ',A,'  Z = ',Z,
     $                '  N =',A-Z
114      format(A,A,A,I3,A,I3,A,I3)
         WRITE(out,103) '** ',DSID
         WRITE(out,103) '** ASCII Graphical Level Scheme file (Radware)'
         WRITE(out,103) '** Converted from ENSDF with '//verstr
         write(out,103) '** This file was created '//sdate//' '//stime
         write(out,103) ' ASCII GLS file format version 1.0'
103      format(A,A,A)

         WRITE(22,114) '** NUCID = ',NUCID,'  A = ',A,'  Z = ',Z,
     $                '  N =',A-Z
         WRITE(22,103) '** ',DSID
         WRITE(22,103) '** ASCII Graphical Level Scheme file (Radware)'
         WRITE(22,103) '** Converted from ENSDF with '//verstr
         write(22,103) '** This file was created '//sdate//' '//stime
      endif

c        find out band properties
      call BdProp

c        initial gls values (most are just defaults)
      ATOMIC_NO = Z
      GAMMA = NGam
      NTLABEL = 0
      CSX = 75.0
      CSY = 85.0
      ASPECT_RATIO = 3.0
      MAX_TANGENT = 0.2679
      MAX_DIST = 999.0
      DEFAULT_WIDTH = 600.0
      DEFAULT_SEP = 150.0
      ARROW_WIDTH = 40.0
      ARROW_LENGTH = 80.0
      ARROW_BREAK = 30.0
      LEVEL_BREAK = 40.0
      L_CSX = 75.0
      L_CSY = 85.0
      L_E_CSX = 75.0
      L_E_CSY = 85.0
      G_CSX = 75.0
      G_CSY = 85.0

      DO I = 1, MAXGAM
         DO J = 1, 10
            GAMDATA(I,J) = 0.0
         ENDDO
         GAMDATA(I,3)  = 10.0
         GAMMA_X1(I)   = 0.0
         GAMMA_X2(I)   = 0.0
         G_LABEL_DX(I) = 0.0
         G_LABEL_DY(I) = 0.0
         GAMMA_FLAG(I) = 0
         G_LABEL_FLAG(I) = 0
      ENDDO
      DO I = 1, MAXLEV
         DO J = 1, 5
            LEVDATA(I,J) = 0.0
         ENDDO
         LEVDATA(I,4)  = +1
         LEVID(I)      = 0
         L_LABEL_DX(I) = 0.0
         L_LABEL_DY(I) = 0.0
         LEVEL_FLAG(I) = 0
         L_LABEL_FLAG(I) = 0
         L_E_LABEL_FLAG(I) = 0
         LEVEL_DX(1,I) = 0.0
         LEVEL_DX(2,I) = 0.0
         L_E_LABEL_DX(I) = 0.0
         L_E_LABEL_DY(I) = 0.0
      ENDDO
      DO I = 1, MAXBAND
         BAND_NX(I)    = DEFAULT_WIDTH 
         B_LABEL_DX(I) = 0.0
         B_LABEL_DY(I) = 0.0
         B_E_LABEL_DX(I) = 0.0
         B_E_LABEL_DY(I) = 0.0
      ENDDO

c     Is data set Adopted levels (for intensity renormalization)?
      ad = 0.1
c%%      if(INDEX(dsid,'ADOPTED').GT.0 .AND. INDEX(dsid,'LEVELS').GT.0)
c%%     $ ad = 1.0

c-------------------------bands---------------------------------

      NBANDS = 0
      LEVEL = 0
      BAND_X0(1) = 50.0 * DEFAULT_WIDTH 
      write (*,*) 'NBAND, NLev, NGam:', NBAND, NLev, NGam

      do j=1,NBAND
         NBANDS = NBANDS + 1
         JBAND = NBANDS
         if (NBANDS.GT.1) then
            BAND_X0(NBANDS) = BAND_X0(NBANDS-1) +
     +                        BAND_NX(NBANDS-1) + DEFAULT_SEP
         endif

         count=0
c**         write(out,'(''* BAND('',A'')   '',A)') BD(j),BANDID(j)
         if(iodd.eq.1) then
            BAND_K = BdK(j)
            STEP = BdStep(j)
c**            write(out,107) BdStr(j),BdK(j),BdPi(j),BdStep(j)
c**107         format('* Band properties: ',A,1X,I3,A,' step:',I2)
         else
            BAND_K = BdK(j)/2.0
            STEP = BdStep(j)/2
c**            write(out,108) BdStr(j),BdK(j),BdPi(j),BdStep(j)/2
c**108         format('* Band properties: ',A,1X,I3,'/2',A,' step:',I2)
         endif

         IF (STEP.EQ.1) THEN
            NBANDS = NBANDS + 1
            BAND_X0(NBANDS) = BAND_X0(NBANDS-1) +
     +                        BAND_NX(NBANDS-1) + DEFAULT_SEP
         ENDIF

c        Print level data for band levels
         do i=1,NLev
            ii=loo(i)
            if(ii.gt.0 .and. Ban(ii).eq.BD(j)) then
               LEVEL = LEVEL + 1
               LEVEL_LOOKUP(i) = LEVEL
               count=count+1
               call label(ii,j,count,LevLab(ii))
               if(JOffs(ii).eq.' ') then
                  r=spin(ii)/float(iodd)
               else
c                 Spin is integer. Add spin offset if present          
                  r=spin(ii)+ioffs(j)/float(iodd)
               endif
               IF (STEP.EQ.1) THEN
                  IF (MOD(r,2.0).LT.0.8) THEN
                     JBAND = NBANDS - 1
                  ELSE
                     JBAND = NBANDS
                  ENDIF
               ENDIF
               call LevStat(UncLev(ii),Spin(ii),parity(ii),JPiMod(ii),
     $                      JOffs(ii),itent)
               BAND_NAME(JBAND) = LevLab(ii)
               LEVDATA(LEVEL,1) = el(ii)
               LEVDATA(LEVEL,2) = del(ii)
               LEVDATA(LEVEL,3) = r
               LEVDATA(LEVEL,4) = 1
               IF (PARITY(II).EQ.'-') LEVDATA(LEVEL,4) = -1
               LEVDATA(LEVEL,5) = BAND_K
               BAND(LEVEL) = JBAND
               L_LABEL_FLAG(LEVEL) = itent
               if (UncLev(ii).ne.' ') LEVEL_FLAG(LEVEL) = 1
            endif
         enddo
      enddo

c-------------------------levels without band assignment--------

      do i=1,NLev
         ii=loo(i)
         if(Ban(ii).eq.' ') then
            if (NBANDS.eq.MAXBAND-3) then
               write (*,*) '**** NBANDS = ', NBANDS
            else
               NBANDS = NBANDS + 1
            endif
            if (NBANDS.GT.1) then
               BAND_X0(NBANDS) = BAND_X0(NBANDS-1) +
     +                           BAND_NX(NBANDS-1) + DEFAULT_SEP
            endif
            LEVEL = LEVEL + 1
            LEVEL_LOOKUP(i) = LEVEL
            call label(ii,0,0,LevLab(ii))
            call LevStat(UncLev(ii),Spin(ii),parity(ii),JPiMod(ii),
     $                   JOffs(ii),itent)
            BAND_NAME(NBANDS) = LevLab(ii)
            LEVDATA(LEVEL,1) = el(ii)
            LEVDATA(LEVEL,2) = del(ii)
            LEVDATA(LEVEL,3) = spin(ii)/float(iodd)
            LEVDATA(LEVEL,4) = 1
            IF (PARITY(II).EQ.'-') LEVDATA(LEVEL,4) = -1
            LEVDATA(LEVEL,5) = BAND_K
            BAND(LEVEL) = NBANDS
            L_LABEL_FLAG(LEVEL) = itent
            if (UncLev(ii).ne.' ') LEVEL_FLAG(LEVEL) = 1
         endif
      enddo

c-------------------------gammas--------------------------------

      if (NGam.gt.MAXGAM) then
         write(*,*) 'ERROR - too many gammas:', NGam
         write(*,*) '      - taking only the first', MAXGAM
         write(4,*) 'ERROR - too many gammas:', NGam
         write(4,*) '      - taking only the first', MAXGAM
         write(22,*) 'ERROR - too many gammas:', NGam
         write(22,*) '      - taking only the first', MAXGAM
      endif
      do jj=1, MIN(NGam, MAXGAM)
         GAMDATA(jj,1) = EGam(jj)
         GAMDATA(jj,2) = dEGam(jj)
         if (dEGam(jj).lt.0.3 .and. dEGam(jj).gt.0.0)
     +                                           G_LABEL_FLAG(jj) = 3
         GAMDATA(jj,3) = IGam(jj)*ad
         IF (IGam(jj).EQ.0.0) GAMDATA(jj,3) = 1.0
         GAMDATA(jj,4) = dIGam(jj)*ad
         if (D(jj).ne.0 .or. DD(jj).gt.0) then
            GAMDATA(jj,7) = D(jj)
            GAMDATA(jj,9) = max(DD(jj),DD2(jj))
         endif
         GAMID(jj,1) = LEVEL_LOOKUP(InLev(jj))
         GAMID(jj,2) = LEVEL_LOOKUP(FinLev(jj))
         if (UncTr(jj).ne.' ') then
            GAMMA_FLAG(jj) = 1
            G_LABEL_FLAG(jj) = G_LABEL_FLAG(jj) + 1
         endif

         DeltaS     = LEVDATA(GAMID(jj,1),3) - LEVDATA(GAMID(jj,2),3)
         IDeltaS    = NINT(DeltaS)
         IF (ABS(DeltaS-FLOAT(IDeltaS)).GT.0.1) THEN
            WRITE(*,*) 'ERROR - one level has half-integer spin,'
            WRITE(*,*) '        other level has integer spin:'
            WRITE(*,'(2(6x,a,f6.1))')
     +         BAND_NAME(BAND(GAMID(jj,1))),LEVDATA(GAMID(jj,1),3),
     +         BAND_NAME(BAND(GAMID(jj,2))),LEVDATA(GAMID(jj,2),3)
            WRITE(4,*) 'ERROR - one level has half-integer spin,'
            WRITE(4,*) '        other level has integer spin:'
            WRITE(4,'(2(6x,a,f6.1))') 
     +         BAND_NAME(BAND(GAMID(jj,1))),LEVDATA(GAMID(jj,1),3),
     +         BAND_NAME(BAND(GAMID(jj,2))),LEVDATA(GAMID(jj,2),3)
            WRITE(22,*) 'ERROR - one level has half-integer spin,'
            WRITE(22,*) '        other level has integer spin:'
            WRITE(22,'(2(6x,a,f6.1))') 
     +         BAND_NAME(BAND(GAMID(jj,1))),LEVDATA(GAMID(jj,1),3),
     +         BAND_NAME(BAND(GAMID(jj,2))),LEVDATA(GAMID(jj,2),3)
         ENDIF
         IDeltaS = ABS(IDeltaS)
         IF (IDeltaS.GT.9) IDeltaS = 9
         IF (LEVDATA(GAMID(jj,1),4)*LEVDATA(GAMID(jj,2),4).GT.0.0) THEN
            IF (MOD(IDeltaS,2).EQ.0) THEN
               CH = 'E'
            ELSE
               CH = 'M'
            ENDIF
         ELSE
            IF (MOD(IDeltaS,2).EQ.0) THEN
               CH = 'M'
            ELSE
               CH = 'E'
            ENDIF
         ENDIF
         IF (IDeltaS.EQ.0) THEN
            IDeltaS = 1
            IF (CH.EQ.'M') THEN
               CH = 'E'
            ELSE
               CH = 'M'
            ENDIF
         ENDIF
c         WRITE (*,50) ENERGY,CH,IDeltaS
c50       FORMAT(' Gamma energy =', F7.1,', Multipolarity = ',A,I1)
         GAML(jj) = CH
         GAMN(jj) = IDeltaS

C           check energy of gamma against level energy difference
         DeltaE = LEVDATA(GAMID(jj,1),1) - LEVDATA(GAMID(jj,2),1)
         DDeltaE = SQRT(
     +      LEVDATA(GAMID(jj,1),2)*LEVDATA(GAMID(jj,1),2) +
     +      LEVDATA(GAMID(jj,2),2)*LEVDATA(GAMID(jj,2),2) +
     +      GAMDATA(jj,2)*GAMDATA(jj,2))
         IF (DDeltaE.le.0.001) DDeltaE = 1.0
         IF (ABS(DeltaE-GAMDATA(jj,1)) .GT. 4.0*DDeltaE .AND.
     +       ABS(DeltaE-GAMDATA(jj,1)) .GT. 3.0) THEN
            WRITE(*,'(a,f9.2)') 'ERROR - level/gamma energies:',
     +         ABS(DeltaE-GAMDATA(jj,1))
            WRITE(*,'(2(6x,a,f6.1))')
     +         BAND_NAME(BAND(GAMID(jj,1))),LEVDATA(GAMID(jj,1),3),
     +         BAND_NAME(BAND(GAMID(jj,2))),LEVDATA(GAMID(jj,2),3)
            WRITE(4,'(a,f9.2)') 'ERROR - level/gamma energies:',
     +         ABS(DeltaE-GAMDATA(jj,1))
            WRITE(4,'(2(6x,a,f6.1))') 
     +         BAND_NAME(BAND(GAMID(jj,1))),LEVDATA(GAMID(jj,1),3),
     +         BAND_NAME(BAND(GAMID(jj,2))),LEVDATA(GAMID(jj,2),3)
            WRITE(22,'(a,f9.2)') 'ERROR - level/gamma energies:',
     +         ABS(DeltaE-GAMDATA(jj,1))
            WRITE(22,'(2(6x,a,f6.1))') 
     +         BAND_NAME(BAND(GAMID(jj,1))),LEVDATA(GAMID(jj,1),3),
     +         BAND_NAME(BAND(GAMID(jj,2))),LEVDATA(GAMID(jj,2),3)

         ENDIF

      enddo

      call bandcheck

C calculate conversion coeffients
      CALL HSICC(ATOMIC_NO,GAMDATA,MAXGAM,CONVT)
C convt contains the coeffients
      DO I = 1, GAMMA
         IF (GAMDATA(I,6) .EQ. 0.0) THEN
            IF (GAML(I) .EQ. 'E') THEN
               J1 = NINT(GAMN(I))
               J2 = NINT(GAMN(I))+5
               IF (J1.GT.4) J1 = 1
               IF (J2.GT.8) J2 = 6
            ELSEIF (GAML(I) .EQ. 'M') THEN
               J1 = NINT(GAMN(I))+4
               J2 = NINT(GAMN(I))+1
               IF (J1.GT.8) J1 = 5
               IF (J2.GT.4) J2 = 2
            ENDIF
            IF (GAMDATA(I,7) .NE. 0) THEN
               DELSQ=GAMDATA(I,7)*GAMDATA(I,7)
               GAMDATA(I,6) = (CONVT(I,J1) + 
     +                         DELSQ*CONVT(I,J2))/(1.0 + DELSQ)
            ELSE
               GAMDATA(I,6) = CONVT(I,J1)
            ENDIF
         ENDIF
      ENDDO

c-------------------from libs/gls/read_write_gls.f-----------------


c        write everything out
      WRITE (OUT,55) ATOMIC_NO, LEVEL, GAMMA, NBANDS, NTLABEL,
     +               CSX, CSY, ASPECT_RATIO, MAX_TANGENT, MAX_DIST,
     +               DEFAULT_WIDTH, DEFAULT_SEP, ARROW_WIDTH,
     +               ARROW_LENGTH, ARROW_BREAK, LEVEL_BREAK,
     +               L_CSX, L_CSY, L_E_CSX, L_E_CSY, G_CSX, G_CSY
      WRITE (OUT,60)
      DO J = 1, LEVEL
         J2 = NINT(2.0*LEVDATA(J,3))
         J1 = J2/2
         IF (J2.EQ.2*J1) THEN
            WRITE(JPI,'(I7)') J1
         ELSE
            WRITE(JPI,'(I5)') J2
            JPI(6:7) = '/2'
         ENDIF
         IF (LEVDATA(J,4).LT.0.0) THEN
            JPI(8:8) = '-'
         ELSE
            JPI(8:8) = '+'
         ENDIF
         J2 = NINT(2.0*LEVDATA(J,5))
         J1 = J2/2
         IF (J2.EQ.2*J1) THEN
            WRITE(KAY,'(I6)') J1
         ELSE
            WRITE(KAY,'(I4)') J2
            KAY(5:6) = '/2'
         ENDIF
         WRITE (OUT,65) J, (LEVDATA(J,K),K=1,2), JPI, KAY, BAND(J),
     +               LEVEL_FLAG(J), L_LABEL_FLAG(J), L_E_LABEL_FLAG(J),
     +               L_LABEL_DX(J), L_LABEL_DY(J),
     +               L_E_LABEL_DX(J), L_E_LABEL_DY(J),
     +               LEVEL_DX(1,J), LEVEL_DX(2,J)
      ENDDO
      WRITE (OUT,70)
      DO J = 1, NBANDS
         WRITE (OUT,75) J, BAND_NAME(J), BAND_X0(J), BAND_NX(J),
     +               B_LABEL_DX(J), B_LABEL_DY(J),
     +               B_E_LABEL_DX(J), B_E_LABEL_DY(J)
      ENDDO
      WRITE (OUT,80)
      DO J = 1, GAMMA
         WRITE (OUT,85) J, GAMDATA(J,1), GAMDATA(J,2), GAML(J),
     +               NINT(GAMN(J)), (GAMID(J,K),K=1,2), 
     +               GAMDATA(J,3), GAMDATA(J,4),
     +               GAMDATA(J,6), GAMDATA(J,8), GAMDATA(J,5), 
     +               GAMDATA(J,10), GAMDATA(J,7), GAMDATA(J,9), 
     +               GAMMA_X1(J), GAMMA_X2(J),
     +               G_LABEL_DX(J), G_LABEL_DY(J),
     +               GAMMA_FLAG(J), G_LABEL_FLAG(J)
      ENDDO
      WRITE (OUT,90)
      DO J = 1, NTLABEL
         WRITE (OUT,95) J, TLABEL(J), TLABEL_NC(J),
     +               TCSX(J), TCSY(J), TLABEL_X(J), TLABEL_Y(J)
      ENDDO

50    FORMAT('** ASCII Graphical Level Scheme file.'/
     +       '** First five lines are reserved for comments.'/
     +       '** This file created ',A/
     +       '** Program GLS,  author D.C. Radford'/
     +       '**'/
     +       ' ASCII GLS file format version 1.0')
55    FORMAT(
     + '**  Z Nlevels Ngammas  Nbands Nlabels CharSizeX CharSizeY',
     + ' ArrowWidFact'/
     + I5,4I8,3F10.2/
     + '**  MaxArrowTan MaxArrowDX DefBandWid DefBandSep ArrowWidth',
     + ' ArrowLength'/
     + F15.6,5F11.2/
     + '** ArrowBreak LevelBreak   LevCSX   LevCSY LevEnCSX LevEnCSY',
     + '   GamCSX   GamCSY'/
     +  2F12.2, 6F9.2)
60    FORMAT('** Level   Energy +/- err     Jpi     K Band#',
     + ' LevelFlag LabelFlag EnLabFlag'/
     + '++   LabelDX   LabelDY EnLabelDX EnLabelDY  LevelDX1  LevelDX2')
65    FORMAT(I6,F11.3,F8.3,A8,A6,I6,3I10,' &'/'++',6F10.2)
70    FORMAT('** Band   Name        X0        NX',
     +       '   LabelDX   LabelDY EnLabelDX EnLabelDY')
75    FORMAT(I5,1X,A8,6F10.2)
80    FORMAT(
     + '** Gamma   Energy +/- err  Mult  ILev  FLev  Intensity +/- err'/
     + '++     ConvCoef +/- error      BrRatio +/- error',
     + '     MixRatio +/- error'/
     + '++   GammaX1  GammaX2  LabelDX  LabelDY GammaFlag LabelFlag')
85    FORMAT(I6,F11.3,F8.3,3X,A,I2,2I6,F11.4,F8.4,' &'/
     +       '++',3(E13.5,E10.3),' &'/
     +       '++',4F10.2,2I10)
90    FORMAT(
     + '** Label                                   text  NChars'/
     + '++     SizeX     SizeY PositionX PositionY')
95    FORMAT(I5,2X,A40,I8,' &'/'++',4F10.2)

c---------------------------------------------------------------

      return
      END
