/* 
 T         Half-life in seconds
 DT        Right uncertainty in half-life
 DT2       Left uncertainty in half-life
 TS        Error string for half-life (contains 'GT','LT', etc.)
 */
      /* Save spin/parity and half-life */
      getjpi(gd.card[nn] + 21, &levels.spin[nlev], gd.parity + nlev,
	     gd.jpimod[nlev], gd.joffs + nlev);
      fendu(gd.card[nn] + 39, ne, gd.ts[nlev], unit, 10, 6);
      un2sec(gd.x, unit, gd.ts[nlev]);
      levels.t[nlev] = gd.x[0];
      levels.dt[nlev] = gd.x[1];
      levels.dt2[nlev] = gd.x[2];


  /* code to write ENSDF/2 data set - code kept here for future use? */
  /* Write ID card */
  fprintf(outfile, "%s\n" gd.card[0]);
  /* Prepare information (I) card */
  if (strncmp(gd.card[0] + 3, "  ", 2)) {
    strcpy(icard, gd.card[0]);
    sprintf(icard + 3,
	    "%3d I  %4d      %4d      %4d      %4d      %4d%.10s      %4d",
	    z, levels.nlev, gammas.ngam, gd.nalpha, gd.nbeta, gd.npar,
	    cpar, gd.nband);
    fprintf(outfile, "%s\n" icard);
  }
  strncpy(mll, "     ", 5);
  strncpy(mgg, "     ", 5);
  for (ij = 1; ij < nn; ++ij) {
    if (!strncmp(gd.card[ij] +  5, "  L ", 4))
      strncpy(mll, gd.card[ij], 5);
    if (!strncmp(gd.card[ij] + 5, "  G ", 4))
      strncpy(mgg, gd.card[ij], 5);
    /* Find last non-blank character */
    for (ik = 79; ik > 0; --ik) {
      if (gd.card[ij][ik] != ' ') break;
    }
    gd.card[ij][ik+1] = '\0';
    /* Make sure level/gamma comments and cont. cards
       have level and band info*/
    if (gd.card[ij][7] == 'L' && *mll != ' ')
      strncpy(gd.card[ij], mll, 5);
    if (gd.card[ij][7] == 'G' && *mgg != ' ')
      strncpy(gd.card[ij], mgg, 5);
    /* Write cards to output */
    fprintf(outfile, "%s\n" gd.card[ij]);
  }
  return 0;

  /* ---from libs/gls/read_write_gls.f---- */
  /* write everything out */
  io_75.ciunit = *out;
  s_wsfe(&io_75);
  do_fio(&c1, &gls1_.atomic_no, 4);
  do_fio(&c1, &l_.level, 4);
  do_fio(&c1, &l_.gamma, 4);
  do_fio(&c1, &gls1_.nbands, 4);
  do_fio(&c1, &gls2_.ntlabel, 4);
  do_fio(&c1, &gls_fig1.csx, 4);
  do_fio(&c1, &gls_fig1.csy, 4);
  do_fio(&c1, &gls_fig1.aspect_ratio, 4);
  do_fio(&c1, &gls_fig1.max_tangent, 4);
  do_fio(&c1, &gls_fig1.max_dist, 4);
  do_fio(&c1, &gls_fig1.default_width, 4);
  do_fio(&c1, &gls_fig1.default_sep, 4);
  do_fio(&c1, &gls_fig1.arrow_width, 4);
  do_fio(&c1, &gls_fig1.arrow_length, 4);
  do_fio(&c1, &gls2_.arrow_break, 4);
  do_fio(&c1, &gls2_.level_break, 4);
  do_fio(&c1, &gls2_.l_csx, 4);
  do_fio(&c1, &gls2_.l_csy, 4);
  do_fio(&c1, &gls2_.l_e_csx, 4);
  do_fio(&c1, &gls2_.l_e_csy, 4);
  do_fio(&c1, &gls2_.g_csx, 4);
  do_fio(&c1, &gls2_.g_csy, 4);
  e_wsfe();
  io_76.ciunit = *out;
  s_wsfe(&io_76);
  e_wsfe();
  for (j = 1; j <= l_.level; ++j) {
    r1 = l_.levdata[j + 1199] * 2.f;
    j2 = i_nint(&r1);
    j1 = j2 / 2;
    /* remove J assignment for unknown spins in even nuclei */
    if (j2 < -1) {
      strncpy(jpi, "        ", 8);
    } else if (j2 == j1 << 1) {
      s_wsfi(&io_78);
      do_fio(&c1, &j1, 4);
      e_wsfi();
    } else {
      s_wsfi(&io_79);
      do_fio(&c1, &j2, 4);
      e_wsfi();
      strncpy(jpi + 5, "/2", 2);
    }
    if (l_.levdata[j + 1799] < 0.f) {
      jpi[7] = '-';
    } else if (l_.levdata[j + 1799] == 0.f) {
      jpi[7] = ' ';
    } else {
      jpi[7] = '+';
    }
    r1 = l_.levdata[j + 2399] * 2.f;
    j2 = i_nint(&r1);
    j1 = j2 / 2;
    if (j2 < 0) {
      strncpy(kay, "      ", 6);
    } else if (j2 == j1 << 1) {
      s_wsfi(&io_80);
      do_fio(&c1, &j1, 4);
      e_wsfi();
    } else {
      s_wsfi(&io_81);
      do_fio(&c1, &j2, 4);
      e_wsfi();
      strncpy(kay + 4, "/2", 2);
    }
    io_82.ciunit = *out;
    s_wsfe(&io_82);
    do_fio(&c1, &j, 4);
    for (k = 1; k <= 2; ++k) {
      do_fio(&c1, &l_.levdata[j + k * 600 - 601], 4);
    }
    do_fio(&c1, jpi, 8L);
    do_fio(&c1, kay, 6L);
    do_fio(&c1, &gls1_.band[j - 1], 4);
    do_fio(&c1, &gls2_.level_flag[j - 1], 4);
    do_fio(&c1, &gls2_.l_label_flag[j - 1], 4);
    do_fio(&c1, &gls2_.l_e_label_flag[j - 1], 4);
    do_fio(&c1, &gls_fig1.l_label_dx[j - 1], 4);
    do_fio(&c1, &gls2_.l_label_dy[j - 1], 4);
    do_fio(&c1, &gls2_.l_e_label_dx[j - 1], 4);
    do_fio(&c1, &gls2_.l_e_label_dy[j - 1], 4);
    do_fio(&c1, &gls2_.level_dx[(j << 1) - 2], 4);
    do_fio(&c1, &gls2_.level_dx[(j << 1) - 1], 4);
    e_wsfe();
  }
  io_84.ciunit = *out;
  s_wsfe(&io_84);
  e_wsfe();
  for (j = 1; j <= gls1_.nbands; ++j) {
    io_85.ciunit = *out;
    s_wsfe(&io_85);
    do_fio(&c1, &j, 4);
    do_fio(&c1, gls1_.band_name + (j - 1 << 3), 8L);
    do_fio(&c1, &gls1_.band_x0[j - 1], 4);
    do_fio(&c1, &gls1_.band_nx[j - 1], 4);
    do_fio(&c1, &gls_fig1.b_label_dx[j - 1], 4);
    do_fio(&c1, &gls2_.b_label_dy[j - 1], 4);
    do_fio(&c1, &gls2_.b_e_label_dx[j - 1], 4);
    do_fio(&c1, &gls2_.b_e_label_dy[j - 1], 4);
    e_wsfe();
  }
  io_86.ciunit = *out;
  s_wsfe(&io_86);
  e_wsfe();
  for (j = 1; j <= l_.gamma; ++j) {
    s_wsfi(&io_88);
    do_fio(&c1, l_.gaml + (j - 1), 1L);
    i4 = i_nint(&l_.gamn[j - 1]);
    do_fio(&c1, &i4, 4);
    e_wsfi();
    if (l_.gaml[j - 1] == ' ') strncpy(multipol, "   ", 3);
    s_wsfi(&io_90);
    do_fio(&c1, &l_.gamdata[j + 2999], 4);
    do_fio(&c1, &l_.gamdata[j + 4499], 4);
    e_wsfi();
    if (l_.gamdata[j + 2999] <= 0.f) strncpy(intens, "           ", 11);
    if (l_.gamdata[j + 4499] <= 0.f) strncpy(intens + 11, "        ", 8);
    io_91.ciunit = *out;
    s_wsfe(&io_91);
    do_fio(&c1, &j, 4);
    do_fio(&c1, &l_.gamdata[j - 1], 4);
    do_fio(&c1, &l_.gamdata[j + 1499], 4);
    do_fio(&c1, multipol, 3L);
    for (k = 1; k <= 2; ++k) {
      do_fio(&c1, &l_.gamid[j + k * 1500 - 1501], 4);
    }
    do_fio(&c1, intens, 19L);
    do_fio(&c1, &l_.gamdata[j + 7499], 4);
    do_fio(&c1, &l_.gamdata[j + 10499], 4);
    do_fio(&c1, &l_.gamdata[j + 5999], 4);
    do_fio(&c1, &l_.gamdata[j + 13499], 4);
    do_fio(&c1, &l_.gamdata[j + 8999], 4);
    do_fio(&c1, &l_.gamdata[j + 11999], 4);
    do_fio(&c1, &gls1_.gamma_x1[j - 1], 4);
    do_fio(&c1, &gls1_.gamma_x2[j - 1], 4);
    do_fio(&c1, &gls_fig1.g_label_dx[j - 1], 4);
    do_fio(&c1, &gls_fig1.g_label_dy[j - 1], 4);
    do_fio(&c1, &gls2_.gamma_flag[j - 1], 4);
    do_fio(&c1, &gls2_.g_label_flag[j - 1], 4);
    e_wsfe();
  }
  io_92.ciunit = *out;
  s_wsfe(&io_92);
  e_wsfe();
  for (j = 1; j <= gls2_.ntlabel; ++j) {
    io_93.ciunit = *out;
    s_wsfe(&io_93);
    do_fio(&c1, &j, 4);
    do_fio(&c1, gls2_.tlabel + (j - 1) * 40, 40L);
    do_fio(&c1, &gls2_.tlabel_nc[j - 1], 4);
    do_fio(&c1, &gls2_.tcsx[j - 1], 4);
    do_fio(&c1, &gls2_.tcsy[j - 1], 4);
    do_fio(&c1, &gls2_.tlabel_x[j - 1], 4);
    do_fio(&c1, &gls2_.tlabel_y[j - 1], 4);
    e_wsfe();
  }
  /* add level energy modification info (+X etc) */
  io_94.ciunit = *out;
  s_wsfe(&io_94);
  e_wsfe();
  for (j = 1; j <= l_.level; ++j) {
    jj = level_lookup[j - 1];
    if (gd.mel[jj - 1] != ' ') {
      io_95.ciunit = *out;
      s_wsfe(&io_95);
      do_fio(&c1, &j, 4);
      do_fio(&c1, gls1_.band_name + (gls1_.band[j - 1] - 1 << 3), 8L);
      do_fio(&c1, gd.mel + (jj - 1), 1L);
      e_wsfe();
    }
  }
  /* ---------------- */

int iget2(char *str)
{
  char *c;

  /* Read the first number in string str */
  for (c = str; *c != '\0'; ++c) {
    if (*c >= '0' && *c <= '9') return iget(c);
  }
  return 0;
} /* iget2 */

int fend(char *ic1, char *mx, char *nx, int ic1_len, int ic2_len)
{
  int i, k, n, m1, jj, kk, ml, mm, nq, iii;
  char *ic2, *c, jc[20], kc[20], jbl[20];

  /* Decode ENSDF data into numeric data and store in gd.x
     String NX returns non-numerical uncertainty */

  ic2 = ic1 + ic1_len;
  k = ic1_len;
  kk = ic2_len;
  strncpy(mx, "   ", 3);
  strncpy(nx, "  ", 2);
  for (i = 0; i < 20; ++i) {
    jbl[i] = kc[i] = jc[i] = ' ';
  }
  gd.x[0] = gd.x[1] = gd.x[2] = 0.f;
  /* Blank value - return */
  if (!strncmp(ic1, jbl, k)) return 0;
  /* Check for nonnumeric quantities */
  strncpy(jc, ic1, k);
  jc[k] = '\0';
  while (1) {
    if ((c = strstr(jc, "+")) && c > jc && *(c - 1) != 'E') {
      if (!NUMB(*(c+1))) {
	/* following character is not a number */
	strncpy(mx, c, 2);
	strncpy(c, "  ", 2);
	if (c + 2 < jc + k && *(c + 2) != ' ') {
	  mx[2] = *(c + 2);
	  *(c + 2) = ' ';
	}
	break;
      }
      /* following character is a number */
      strncpy(mx + 1, c - 1, 2);
      strncpy(c - 1, "  ", 2);
      if (c - 2 >= jc && *(c - 2) != ' ') {
	mx[0] = *(c - 2);
	*(c - 2) = ' ';
      }
    } else if ((c = strstr(jc, "?"))) {
      *c = ' ';
      strncpy(mx, "  ?", 3);
    } else if ((c = strstr(jc, "("))) {
      *c = ' ';
      strncpy(mx, " ()", 3);
      if ((c = strstr(jc, ")"))) *c = ' ';
    } else if ((c = strstr(jc, "X"))) {
      strncpy(c, "0+X", 3);
      continue;
    } else if ((c = strstr(jc, "Y"))) {
      strncpy(c, "0+Y", 3);
      continue;
    } else if ((c = strstr(jc, "SN")) || (c = strstr(jc, "SP"))) {
      strncpy(c, "  ", 2);
      strncpy(mx + 1, c, 2);
      continue;
    }
    break;
  }
  /*
    read(jc(1:k),1000,err=101) x(1)
    1000  format(bn,F20.0)
  */
  if ((sscanf(jc, "%lf", &gd.x[0])) != 1) {
    iii = 0;
    for (i = 0; i < k; ++i) {
      if (NUMB(jc[i]) || jc[i] == '.') continue;
      jc[i] = ' ';
      if (iii < 2) mx[iii] = jc[i];
      ++iii;
    }
  }
  /* Check uncertainties for alphanumerics */
  jj = 0;
  if (!strncmp(ic2, jbl, kk)) return 0;
  for (i = 0; i < kk; ++i) {
    if (ic2[i] == '-' || ic2[i] == '+') continue;
    if (ic2[i] != ' ' && !NUMB(ic2[i])) {
      strncpy(nx, ic2 + i, 2);
      return 0;
    }
    if (NUMB(ic2[i])) jj = i + 1;
  }
  if (jj == 0) return 0;

  while (1) {
    /* Process uncertainties */
    mm = k;
    nq = 0;
    if ((c = strstr(jc, "E")) || (c = strstr(jc, "e"))) {
      mm = c - jc;
      strncpy(kc + mm, c, k - mm);
    }
    m1 = 2;
    for (i = 1; i <= mm; ++i) {
      n = mm - i;
      if (jc[n] == ' ' || jc[n] == '.') {
	kc[n] = jc[n];
	continue;
      }
      kc[n] = '0';
      if (nq == 1) continue;
      while (jj > 0) {
	if (ic2[--jj] != ' ') {
	  kc[n] = ic2[jj];
	  break;
	}
      }
      if (jj <= 0 || ic2[jj - 1] == '-' || ic2[jj - 1] == '+') nq = 1;
    }
    /*
      read(kc(1:k),1000,err=1514) x(m1)
      1000  format(bn,F20.0)
    */
    sscanf(kc, "%lf", &gd.x[m1 - 1]);
    if (m1 == 3 || gd.x[2] > 1e-20) return 0;
    if ((jj <= 0) || (ic2[jj - 1] != '-' && ic2[jj - 1] != '+')) {
      gd.x[2] = gd.x[1];
      return 0;
    }
    if (ic2[jj - 1] == '+') {
      m1 = 3;
    } else {
      gd.x[2] = gd.x[1];
      gd.x[1] = 0.f;
      ml = 2;
    }
    strncpy(kc, jbl, 20);
    --jj;
    nq = 0;
  }
} /* fend */

int lbsup(char *str)
{
  char dumstr[80];

  /* remove leading blanks from str */
  while (*str != ' ') {
    strcpy(dumstr, str + 1);
    strcpy(str, dumstr);
  }
  return 0;
} /* lbsup */

int charad(int n, char *ic)
{
  int n1, n2, nn;

  /* Imbed character equivalent of N in IC */
  strncpy(ic, "  ", 2);
  /* Maximum N is 3375 (63*52-1+100) */
  if (n >= 3376)
    stopit(" Subroutine CHARAD", "", "",
	   " ** Character array limit exceeded **", n);
  /* For N=0-99, use N */
  if (n <= 99) {
    sprintf(ic, "%2d", n);
    return 0;
  }
  /* Base 63x52, N1=1st character, N2=2nd character */
  nn = n - 100;
  n1 = nn / 52;
  n2 = nn - n1 * 52;
  /* For N1 use blank,0-9,A-Z,a-z, i.e. 1+10+26+26=63 combinations
     For N1=0 use blank */
  if (n1 >= 1) {
    /* For N1=1-10 use 0-9 */
    if (n1 <= 10) {
      sprintf(ic, "%d", --n1);
    } else {
      /* For N1=11-36 use A-Z */
      if (n1 <= 36) {
	n1 += 54;
	/* For N1=37-62 use a-z */
      } else if (n1 >= 37) {
	n1 += 60;
      }
      *ic = (char) n1;
    }
  }
  /* For N2 use A-Z,a-z, i.e. 26+26=52 combinations
     For N2=0-25 use A-Z */
  if (n2 <= 25) {
    n2 += 65;
    /* For N2=26-51 use a-z */
  } else if (n2 >= 26) {
    n2 += 71;
  }
  ic[1] = (char) n2;
  return 0;
} /* charad */

int un2sec(double *x, char *unit, char *lim)
{
  /* Initialized data */
  static char *tunits[17] =
  { "MEV","KEV"," EV"," AS"," FS"," PS"," NS"," US"," MS",
    " S "," M "," H "," D "," Y "," KY"," MY"," GY"};
  static double tfact[17] =
  { 4.5624e-22, 4.5624e-19, 4.5624e-16, 1e-18, 1e-15, 1e-12, 1e-9, 1e-6, .001,
    1., 60., 3600., 86400., 31558120., 3.155812e10, 3.155812e13, 3.155812e16 };

  double t, tt;
  int i;

  if (x[0] <= 0.0) return 0;
  for (i = 0; i < 17; ++i) {
    if (!strcmp(unit, tunits[i])) {
      strncpy(unit, " S ", 3);
      if (i > 2) {
	/* Convert half-life and errors from UNIT to seconds */
	x[0] *= tfact[i]; x[1] *= tfact[i]; x[2] *= tfact[i];
	return 0;
      }
      /* Convert width and errors in UNIT to half-life in seconds */
      t = x[1] / x[0];
      tt = x[2] / x[0];
      x[0] = tfact[i] / x[0];
      x[1] = x[0] * tt;
      x[2] = x[0] * t;
      strncpy(unit, " S ", 3);
      /* Reverse limits */
      if (strncmp(lim, "  ", 2)) lbsup(lim);
      if (*lim == 'L') {
	*lim = 'G';
      } else if (*lim == 'G') {
	*lim = 'L';
      }
      return 0;
    }
  }
  return 0;
} /* un2sec */

int fendu(char *ic1, char *mx, char *nx, char *unit, int ic1_len, int ic2_len)
{
  /* Initialized data */
  static char *units3[17] = {" S ", " M ", " H ", " D ", " Y ", " MS", " US", 
			     " NS", " PS", " FS", " AS", " KY", " MY", " GY",
			     " EV", "KEV", "MEV"};

  int i, k, n, m1, jj, kk, ml, mm, nq, iii;
  char *ic2, *c, jc[20], kc[20], jbl[20];

  /* Decode ENSDF data into numeric data and store in gd.x
     Array gd.x returns value and asymmetric uncertainties
     String NX returns non-numerical uncertainty
     String MX returns '  ?' or ' ()'
     String UNIT returns valid unit */

  ic2 = ic1 + ic1_len;
  k = ic1_len;
  kk = ic2_len;
  strncpy(mx, "   ", 3);
  strncpy(nx, "  ", 2);
  strncpy(unit, "   ", 3);
  gd.x[0] = gd.x[1] = gd.x[2] = 0.f;
  /* Blank value - return */
  if (*ic1 == ' ') return 0;
  strncpy(jc, ic1, 20);
  jc[k] = '\0';
  for (i = 0; i < 20; ++i) {
    jbl[i] = kc[i] = ' ';
  }
  /* Find unit, put in string UNIT and blank it out from JC */
  for (i = 0; i < 17; ++i) {
    if ((c = strstr(jc, units3[i]))) {
      strncpy(unit, units3[i], 3);
      strncpy(c, "   ", 3);
      break;
    }
  }
  /* Check for nonnumeric quantities */
  while (1) {
    if ((c = strstr(jc, "+")) && c > jc && *(c - 1) != 'E') {
      if (!NUMB(*(c+1))) {
	/* following character is not a number */
	strncpy(mx, c, 2);
	strncpy(c, "  ", 2);
	if (c + 2 < jc + k && *(c + 2) != ' ') {
	  mx[2] = *(c + 2);
	  *(c + 2) = ' ';
	}
	break;
      }
      /* following character is a number */
      strncpy(mx + 1, c - 1, 2);
      strncpy(c - 1, "  ", 2);
      if (c - 2 >= jc && *(c - 2) != ' ') {
	mx[0] = *(c - 2);
	*(c - 2) = ' ';
      }
      break;
    }
    if ((c = strstr(jc, "?"))) {
      *c = ' ';
      strncpy(mx, "  ?", 3);
      break;
    }
    if ((c = strstr(jc, "("))) {
      *c = ' ';
      strncpy(mx, " ()", 3);
      if ((c = strstr(jc, ")"))) *c = ' ';
      break;
    }
    if ((c = strstr(jc, "X"))) {
      strncpy(c, "0+X", 3);
      continue;
    }
    if ((c = strstr(jc, "Y"))) {
      strncpy(c, "0+Y", 3);
      continue;
    }
    if ((c = strstr(jc, "SN")) || (c = strstr(jc, "SP"))) {
      strncpy(c, "  ", 2);
      strncpy(mx + 1, c, 2);
      continue;
    }
    break;
  }
  /*
    read(jc(1:k),1000,err=101) x(1)
    1000  format(bn,F20.0)
  */
  if ((sscanf(jc, "%lf", &gd.x[0])) != 1) {
    iii = 0;
    for (i = 0; i < k; ++i) {
      if (NUMB(jc[i]) || jc[i] == '.') continue;
      jc[i] = ' ';
      if (iii < 2) mx[iii] = jc[i];
      ++iii;
    }
  }
  /* Check uncertainties for alphanumerics */
  jj = 0;
  if (!strncmp(ic2, jbl, kk)) return 0;
  for (i = 0; i < kk; ++i) {
    if (ic2[i] == '-' || ic2[i] == '+') continue;
    if (ic2[i] != ' ' && !NUMB(ic2[i])) {
      strncpy(nx, ic2 + (i - 1), 2);
      return 0;
    }
    if (NUMB(ic2[i])) jj = i + 1;
  }
  if (jj == 0) return 0;

  while (1) {
    /* Process uncertainties */
    mm = k;
    nq = 0;
    if ((c = strstr(jc, "E")) || (c = strstr(jc, "e"))) {
      mm = c - jc;
      strncpy(kc + mm, c, k - mm);
    }
    m1 = 2;
    for (i = 1; i <= mm; ++i) {
      n = mm - i;
      if (jc[n] == ' ' || jc[n] == '.') {
	kc[n] = jc[n];
	continue;
      }
      kc[n] = '0';
      if (nq == 1) continue;
      while (jj > 0) {
	if (ic2[--jj] != ' ') {
	  kc[n] = ic2[jj];
	  break;
	}
      }
      if (jj <= 0 || ic2[jj - 1] == '-' || ic2[jj - 1] == '+') nq = 1;
    }
    /*
      read(kc(1:k),1000,err=1514) x(m1)
      1000  format(bn,F20.0)
    */
    sscanf(kc, "%lf", &gd.x[m1 - 1]);
    if (m1 == 3 || gd.x[2] > 1e-20) return 0;
    if ((jj <= 0) || (ic2[jj - 1] != '-' && ic2[jj - 1] != '+')) {
      gd.x[2] = gd.x[1];
      return 0;
    }
    if (ic2[jj - 1] == '+') {
      m1 = 3;
    } else {
      gd.x[2] = gd.x[1];
      gd.x[1] = 0.f;
      ml = 2;
    }
    strncpy(kc, jbl, 20);
    --jj;
    nq = 0;
  }
} /* fendu */

int skip(void)
{
  /* Skips cards until EOF or End of Data Set */
  while (1) {
    fgets(gd.card[0], 80, in_file);
    if (gd.card[0][0] == ' ') break;
    if (gd.card[0][0] == 0)  { /* End-of-file found */
      gd.theend = 1;
      break;
    }
  }
  return 0;
} /* skip */

int padlft(char *str, int l)
{
  int lc;
  char dumstr[256];

  /* make str l characters long by either taking away blanks or
     filling with blanks to the left */
  if ((lc = strlen(str)) >= l) {
    while (*str == ' ' && lc > l) {
      strcpy(dumstr, str + 1);
      strcpy(str, dumstr);
      lc--;
    }
    return 0;
  }
  memset(dumstr, ' ', 200);
  strcpy(dumstr + l - lc, str);
  strcpy(str, dumstr);
  return 0;
} /* padlft */

int tbsup(char *str)
{
  int i;

  /* remove trailing blanks from str */
  for (i = strlen(str) - 1; i >= 0 && str[i] == ' '; --i) {
    str[i] = '\0';
  }
  return 0;
} /* tbsup */

int squeez(char *str, char *str1)
{
  int lc, lc1;
  char dumstr[80], *c;

  /* remove all occurrances of str1 from str.
     str1 must be of the proper length, i.e. contaning no nulls. */

  lc = strlen(str);
  lc1 = strlen(str1);
  if (lc1 <= 0 || lc < lc1) return 0;
  while ((c = strstr(str, str1))) {
    strcpy(dumstr, c + lc1);
    strcpy(c, dumstr);
  }
  return 0;
} /* squeez */

int sresto(char *str, int str_len)
{
  int lc;

  /* restores partly nulled string str, so that it is padded with
     blanks instead of nulls */

  lc = strlen(str);
  while (lc++ < str_len) {
    strcat(str, " ");
  }
  return 0;
} /* sresto */

int mul(int ll, char *dum2)
{
  /* Get multipolarity of gamma ll for WAGS. */
  strncpy(dum2, "  ", 2);
  /* Get multipolarity from ML and MLPar */
  if (gammas.ml[ll - 1][0] >= 0) {
    sprintf(dum2 + 1, "%d", gammas.ml[ll - 1][0]);
    if (gd.mlpar[ll - 1] != ' ') {
      *dum2 = 'E';
      if (gd.mlpar[ll - 1] == '+') {
	if (pow(-1.0, (double) gammas.ml[ll - 1][0]) == -1) *dum2 = 'M';
      } else if (gd.mlpar[ll - 1] == '-') {
	if (pow(-1.0, (double) gammas.ml[ll - 1][0]) == 1) *dum2 = 'M';
      }
    }
  }
  return 0;
} /* mul */

int itypes(char *str, int len)
{
  int ret_val, iend, i;

  /* returns the type code of the string str.
     null                    0
     numeric (0-9)           1
     alpha (A-Z or a-z)      2
     blank                   3
     other                   4
     mixed                  -1
     fortran number         -2 */

  iend = strlen(str);
  if (len > 0 && iend > len) iend = len;
  if (iend <= 0) return 0;
  ret_val = itype(*str);
  for (i = 1; i < iend; ++i) {
    if (ret_val != itype(str[i])) {
      for (i = 0; i < iend; ++i) {
	if ((str[i] < '0' || str[i] > '9') &&
	    str[i] != ' ' && str[i] != '+' && str[i] != '-' &&
	    str[i] != '.' && str[i] != 'E' && str[i] != 'e' ) return -1;
      }
      return -2;
    }
  }
  return ret_val;
} /* itypes */

int itype(char c)
{
  /* returns the character type code of the input character c
     numeric (0-9)           1
     alpha (a-z or a-z)      2
     blank                   3
     other                   4 */

  if (c >= '0' && c <= '9') return 1;
  if ((c >= 'A' && c <= 'Z') || (c >= 'a' && c <= 'z')) return 2;
  if (c == ' ') return 3;
  return 4;
} /* itype */

int numb(char c)
{
  /* return 1 if c is an int between 0 and 9. */
  if (c >= '0' && c <= '9') return 1;
  return 0;
} /* numb */

int putml(char *mult, int *ml, char parity, char *mlmod)
{
  /* Initialized data */
  static char type[2] = "EM";

  int itype1, itype2;
  char temp[10];

  /* Writes multipolarity to mult character string */
  /* Parameter adjustments */
  --ml;

  strcpy(mult, " ");
  if (!strncmp(mlmod, "***", 3)) {
    strncpy(mult, "**************", 14);
    return 0;
  }
  if (ml[1] < 0 && parity == ' ') return 0;
  strncpy(temp, "**********", 10);
  /* 1234567890
     (E2(+M3)
     Write multipolarity */
  if (parity != ' ') {
    if (parity == '-') {
      itype1 = 1;
      if ((ml[1] / 2 << 1) - ml[1] == 0) itype1 = 2;
    } else {
      itype1 = 2;
      if ((ml[1] / 2 << 1) - ml[1] == 0) itype1 = 1;
    }
    s_wsfi(&io_115);
    do_fio(&c1, type + (itype1 - 1), 1L);
    e_wsfi();
    s_wsfi(&io_116);
    do_fio(&c1, &ml[1], 4);
    e_wsfi();
    if (ml[2] > 0) {
      itype2 = 1;
      if (itype1 == 1) itype2 = 2;
      s_wsfi(&io_118);
      do_fio(&c1, &ml[2], 4);
      e_wsfi();
      s_wsfi(&io_119);
      do_fio(&c1, type + (itype2 - 1), 1L);
      e_wsfi();
      temp[4] = '+';
    }
    /* Handle D, Q, and O */
  } else {
    if (ml[1] == 1) temp[1] = 'D';
    if (ml[1] == 2) temp[1] = 'Q';
    if (ml[1] == 3) temp[1] = 'O';
    if (ml[2] > 0) {
      temp[4] = '+';
      if (ml[2] == 2) temp[5] = 'Q';
      if (ml[2] == 3) temp[5] = 'O';
    }
  }
  /* Handle brackets/parentheses */
  if (*mlmod == '[') {
    temp[0] = '[';
    temp[7] = ']';
  }
  if (*mlmod == '(') {
    temp[0] = '(';
    temp[7] = ')';
  } else if (mlmod[1] == '(') {
    temp[3] = '(';
    temp[7] = ')';
  }
  /* Squeeze out *:s */
  squeez(temp, "*");
  sresto(temp, 10);
  strncpy(mult, temp, 10);
  return 0;
} /* putml */

int scal10(int *ix, int *idx, int *ipwr)
{
  /* if idx = 10 or 20 and ix a multiple of 10,
     reduce ix, idx, by 10 and change ipwr
     dummy arguments:
     ix    input value (assigned)
     idx   input uncertainty (assigned)
     idx   input exponent so that value of x=ix*10**ipwr (assigned) */

  if (*ix % 10 == 0 && *idx % 10 == 0) {
    *ix /= 10;
    *idx /= 10;
    ++(*ipwr);
  }
  return 0;
} /* scal10 */

int dscadx(double *dz, int *idx, int *ipwr)
{
  double d;

  /* compute idx in the range 3 to 25.
     ipwr is power of 10 to get back to original.
     dummy arguments:
     dz    input uncertainty
     idx   computed uncertainty (assigned)
     ipwr  power of 10 so that dz=idx*10**ipwr (assigned) */

  d = *dz;
  *ipwr = 0;
  /* ---  D < 3.0, MULTIPLY BY 10. */
  while (d < 3.f) {
    d *= 10.f;
    --(*ipwr);
  }
  /* ---  D > 25.0, DIVIDE BY 10. */
  while (d > 25.f) {
    d /= 10.f;
    ++(*ipwr);
   }
  /* ---  D IN RANGE 3 TO 25, ROUND AND FIX. */
  *idx = (int) (d + 0.9f);
  return 0;
} /* dscadx */

int dscalx(double *z, int *ix, int *ipwr)
{
  double x;

  /* compute ix based on z and ipwr
     dummy arguments:
     z     input value
     ix    renormalized z (assigned)
     ipwr  power of 10 so that z=ix*10**ipwr */

  /* ---  scale and fix x. */
  x = *z * pow(0.5, (double)(-(*ipwr)));
  if (x < 0.0) {
    *ix = (int) (x - 0.5);
  } else {
    *ix = (int) (x + 0.5);
  }
  return 0;
} /* dscalx */

int putin(char *obj, int loc, char *src, int ld)
{
  char dumstr[256];

  /* inserts (by pushing to the right) the first ld characters
     of src into obj starting at loc */
  if (loc > 0) {
    strcpy(dumstr, obj + loc - 1);
    strncpy(obj + loc - 1, src, ld);
    strcpy(obj + loc - 1 + ld, dumstr);
  }
  return 0;
} /* putin */

int padrt(char *str, int l)
{
  int i;

  /* make str l characters long by either taking away blanks or
     filling with blanks to the right */
  str[l + 1] = '\0';
  for (i = strlen(str); i < l; ++i) {
    strcat(str, " ");
  }
  return 0;
} /* padrt */

int cnvis(int n, char *str, int ld)
{
  char work[40];

  /* converts the int n into a right justified string, str,
     with length ld. if ld=0, the string length is that of the
     squeezed string. if n is too large for ld characters or for
     max. length of str, stars fill str.
     maximum int length is 20 characters.
     dummy arguments:
     n     input int
     str   output string (assigned)
     ld    current length of str */

  /* ---  write number in work string */
  sprintf(work, "%d", n);
  if (ld > 0 && strlen(work) > ld) {
    /* ---  not enough space for number. */
    strncpy(str, "********************", ld);
    str[ld] = '\0';
    return 0;
  }
  strcpy(str, work);
  if (ld > 0) padlft(str, ld);
  return 0;
} /* cnvis */

int cnvixs(int ix, int ipwr, char *sx, int lenx)
{
  float x;
  int izer, jpwr, i, neg, lct;
  char temp[40], work[40];

  /* convert ix with scale factor ipwr to a string sx of length
     lenx.  if the string space is too small, return stars (*).
     if ipwr > 0 use exponential format.
     if ix > 0 and ix * 10 ** ipwr < 1e-4 use exponential format.
     dummy arguments:
     ix    input int
     ipwr  power of 10 to normalize ix to correct value
     sx    output string (assigned)
     lenx  current length of output string sx */

  /* convert ix to string mode */
  cnvis(ix, temp, 0);

  /* neg is control for negative number (leave space for sign) */
  neg = 0;
  if (ix < 0) neg = 1;

  /* special formatting based on ipwr */
  if (ipwr == 0) goto DONE;  /* ipwr = 0, return int format */

  if (ipwr < 0) x = (float) (ix) * pow(10.0, (double) ipwr);
  if (ipwr > 0 || fabs(x) < 1e-4f) {
    /* ipwr > 0, return dig . fract E exp
       compute exponent value */
    /* use exponential format for very small numbers, except 0.0 */
    if (ix == 0) {
      strcpy(temp, "0.0");
      goto DONE;
    }
    /* compute exponent value */
    jpwr = strlen(temp) - 1 + ipwr - neg;
    /* add decimal point to number */
    putin(temp, neg + 2, ".", 1);
    /* add exponent to end of string */
    if (ipwr > 0) {
      strcat(temp, "E+");
    } else {
      strcat(temp, "E");
    }
    cnvis(jpwr, work, 0);
    strcat(temp, work);
    goto DONE;
  }

  lct = strlen(temp);
  if (lct - neg > -(ipwr)) {
    /* dig.fraction
       find where decimal point belongs and insert it */
    putin(temp, lct + 1 + ipwr, ".", 1);
    goto DONE;
  } else {
    /* 0.0's fraction
       find number of leading zeros and insert */
    izer = neg - ipwr - lct;
    if (izer >= 1) {
      for (i = 1; i <= izer; ++i) {
	putin(temp, i + neg, "0", 1);
      }
    }
    /* insert decimal point and first zero. */
    putin(temp, neg + 1, "0.", 2);
  }
DONE:
  /* check that lenstr(temp) <= lenx. if so put temp in sx,
     if not fill sx with stars */
  if (strlen(temp) <= lenx) {
    strcpy(sx, temp);
  } else {
    strncpy(sx, "********************", lenx);
  }
  padlft(sx, lenx);
  return 0;
} /* cnvixs */

int cardout(int *out, char *ocard)
{
  /* Write ocard without trailing blanks to file out */
  tbsup(ocard);
  io_183.ciunit = *out;
  s_wsfe(&io_183);
  do_fio(&c1, ocard, ocard_len);
  e_wsfe();
  return 0;
} /* cardout */

int wend(double *z, char *sx, int *lenx, char *sdx, int *lendx, char *slim,
	 char *unit)
{
  double d1, t, x, dx1, dx2;
  int isig, ipwr, ix, idx, idx2;
  char temp1[10];

  /* Writes value (Z(1) and asymmetric uncertainty Z(2),Z(3)
     to strings SX and SDX. If LENDX<6, only first uncertainty (Z(2))
     is written. If Z(2)=0.0, uncertainty is replaced by SLIM.
     If UNIT non-blank, it is appended to value. */

  /* Parameter adjustments */
  --z;

  x = z[1];
  dx1 = z[2];
  dx2 = z[3];
  strcpy(sx, " ");
  strcpy(sdx, " ");
  if (dx1 > 0.f) {
    /* Scale according to smaller of dx1 and dx2: */
    t = dx1;
    if (dx2 < t && dx2 > 0.) t = dx2;
    dscadx(&t, &idx, &ipwr);
    dscalx(&dx1, &idx, &ipwr);
    dscalx(&x, &ix, &ipwr);
    if (dx1 * 20 <= abs(x)) scal10(&ix, &idx, &ipwr);
    cnvixs(&ix, &ipwr, sx, lenx);
    cnvis(&idx, sdx, lendx);
    lbsup(sx);
    tbsup(sx);
    strcat(sx, unit);
    lbsup(sdx);
    /* Finished if dx2=0, LENDX<6 or DX1=DX2 */
    if (dx2 <= 0. || *lendx < 6 || dx1 == dx2) goto L90;
    /* Calculate other error limit */
    strcpy(temp1, "+");
    strcat(temp1, sdx);
    tbsup(temp1);
    dscalx(&dx2, &idx2, &ipwr);
    cnvis(&idx2, sdx, lendx, sdx_len);
    lbsup(sdx, sdx_len);
    strcat(temp1, "-");
    strcat(temp1, sdx);
    strncpy(sdx, temp1, 10);
  } else {
    /* Determine number of 2 significant digits in X
       SDX is replaced by SLIM */
    isig = 2;
    if (x >= 100. && x < 1e3) isig = 3;
    if (x >= 1e3 && x < 1e4) isig = 4;
    if (x >= 1e4 && x < 1e5) isig = 5;
    /* FIND PROPER IPWR. */
    t = 0.f;
    if (x != 0.f) {
      d1 = abs(x);
      t = log10(d1);
    }
    if (t < 0.f) t += -1.f;
    ipwr = (int) t - isig + 1;
    dscalx(&x, &ix, &ipwr);
    cnvixs(&ix, &ipwr, sx, lenx, sx_len);
    lbsup(sx, sx_len);
    tbsup(sx, sx_len);
    strcat(sx, unit);
    strncpy(sdx, slim, sdx_len);
  }
L90:
  sresto(sx, sx_len);
  sresto(sdx, sdx_len);
  return 0;
} /* wend */

int sec2un(double *x, char *unit)
{
  /* Initialized data */
  static char tunits[3*17] = "MEV" "KEV" " EV" " AS" " FS" " PS" " NS" 
    " US" " MS" " S " " M " " H " " D " " Y " " KY" " MY" " GY";
  static double tfact[17] = { 4.5624e-22,4.5624e-19,4.5624e-16,1e-18,
			      1e-15,1e-12,1e-9,1e-6,.001,1.,60.,3600.,86400.,
			      31558120.,3.155812e10,3.155812e13,3.155812e16 };

  int iunit;

  /* Scales half-life/errors (X) so that T1/2 is given in an 
     appropriate unit.
     1 YEAR IS 365.256 DAYS
     T1/2(S)=LN(2)*HBAR/WIDTH(EV) WHERE
     LN(2)*HBAR=C=4.5624*10**-16 EV*S --> 1/C=2.1918*10**15 */

  /* Parameter adjustments */
  --x;

  /* Determine the appropriate unit */
  if (x[1] < 1e-19) {
    strncpy(unit, " S  ", 4);
    return 0;
  } else if (x[1] <= 1e-16) {
    /* AS */
    iunit = 4;
    goto L10;
  } else if (x[1] <= 1e-13) {
    /* FS */
    iunit = 5;
    goto L10;
  } else if (x[1] <= 1e-10) {
    /* PS */
    iunit = 6;
    goto L10;
  } else if (x[1] <= 1e-7) {
    /* NS */
    iunit = 7;
    goto L10;
  } else if (x[1] <= 1e-4) {
    /* US */
    iunit = 8;
    goto L10;
  } else if (x[1] <= .1) {
    /* MS */
    iunit = 9;
    goto L10;
  } else if (x[1] < 60.f) {
    /* S */
    iunit = 10;
    goto L10;
  } else if (x[1] < 3600.f) {
    /* M */
    iunit = 11;
    goto L10;
  } else if (x[1] < 86400.f) {
    /* H */
    iunit = 12;
    goto L10;
  } else if (x[1] < 31558120.) {
    /* D */
    iunit = 13;
    goto L10;
  } else if (x[1] < 3.155812e10) {
    /* Y */
    iunit = 14;
    goto L10;
  } else if (x[1] < 3.155812e13) {
    /* KY */
    iunit = 15;
    goto L10;
  } else if (x[1] < 3.155812e16) {
    /* MY */
    iunit = 16;
    goto L10;
  } else if (x[1] < 3.155812e19) {
    /* GY */
    iunit = 17;
    goto L10;
  }
  strncpy(unit, " S  ", 4);
  return 0;
L10:
  /* Convert half-life and errors from seconds to UNIT */
  strncpy(unit, tunits + (iunit - 1) * 3, 3);
  x[1] /= tfact[iunit - 1];
  x[2] /= tfact[iunit - 1];
  x[3] /= tfact[iunit - 1];
  return 0;
} /* sec2un */

void gama(complex *ret_val, complex *x)
{
  /* Builtin functions */
  void c_div(complex *, complex *, complex *);

  complex q1, q2, q3, xtmp;
  int j, n;

  /* z = gamma(x) for all values of x (z, x complex).
     dummy argument:  x     single precision complex input value */

  if (x->r >= 0.f) {
    if (x->i >= 0.f) {
      gamz(&q1, x);
      ret_val->r = q1.r,  ret_val->i = q1.i;
    } else {
      /* fortran: GAMA = CONJG(GAMZ(CONJG(X)) */
      q2.r = x->i; q2.i = x->r;
      gamz(&q1, &q2);
      ret_val->r = q1.i,  ret_val->i = q1.r;
    }
    return;
  }

  n = 1.f - x->r;
  q1.r = x->r + (float) n, q1.i = x->i;
  xtmp.r = q1.r, xtmp.i = q1.i;
  j = 0;
  if (x->i >= 0.f) {
    gamz(&q1, &xtmp);
    ret_val->r = q1.r,  ret_val->i = q1.i;
  } else {
      /* fortran: GAMA = CONJG(GAMZ(CONJG(XTMP)) */
    q2.r = xtmp->i; q2.i = xtmp->r;
    gamz(&q1, &q2);
    ret_val->r = q1.i,  ret_val->i = q1.r;
  }

  while (1) {
    xtmp.r = x->r + (float) j, xtmp.i = x->i;
    c_div(&q1,  ret_val, &xtmp);
    ret_val->r = q1.r,  ret_val->i = q1.i;
    if (++j >= n) break;
  }
  return;
} /* gama */

void gamz(complex *ret_val, complex *x)
{
  /* Initialized data */
  static float pi = 2.50662827463f;

  complex q1, xtmp, c, z1, z2, xt;
  float s, t, fn, f1n;
  int j, m;

  /* z = gamma(x) for x(real), x(imag) >= 0.
     note - gamz calls gam1 which modifies its argument */

  if (x->i <= 1.f) {
    xt.r = x->r, xt.i = x->i;
    gam1(&q1, &xt);
    ret_val->r = q1.r,  ret_val->i = q1.i;
    return;
  }

  m = x->i;
  fn = (float) (m + 1);
  xt.r = xtmp.r = x->r / fn, xt.i = xtmp.i = x->i / fn;
  gam1(&z1, &xt);
  f1n = 1.f / fn;

  j = 1;
  while (1) {
    xtmp.r += f1n;
    xt.r = xtmp.r, xt.i = xtmp.i;
    gam1(&z2, &xt);
    q1.r = z1.r * z2.r - z1.i * z2.i, q1.i = z1.r * z2.i + z1.i * z2.r;
    z1.r = q1.r, z1.i = q1.i;
    if (++j > m) break;
  }

  s = pow((double) fn, (double) (x->r - .5f)) / pow((double) pi, (double) m);
  t = x->i * log((double) fn);
  c.r = s * cos((double) t), c.i = s * sin((double) t);
  ret_val->r = c.r * z1.r - c.i * z1.i,  ret_val->i = c.r * z1.i + c.i * z1.r;
  return;
} /* gamz */

void gam1(complex *ret_val, complex *x)
{
  complex q1;
  float fj, fn;
  int j, n;

  /* z = gamma(x) for x(real) >= 0, 0 <= x(imag) <= 1. */

  if (x->r <= 1.f) {
    gam2(ret_val, x);
    return;
  }

  n = x->r;
  if (x->r == 0.f) --n;
  fn = (float) n;
  x->r -= fn;
  gam2(ret_val, x);

  j = 0;
  while (1) {
    fj = x->r + (float) j;
    q1.r = fj * ret_val->r - x->i * ret_val->i,
      q1.i = fj * ret_val->i + x->i * ret_val->r;
    ret_val->r = q1.r,  ret_val->i = q1.i;
    if (++j >= n) break;
  }
  return;
} /* gam1 */

void gam2(complex *ret_val, complex *x)
{
  /* Initialized data */
  static float a[9] = { 0.0f, 1.0f, 1.2536302998f,
			0.062294126401f, -0.19367439704f, 9.5294089001e-3f,
			0.010021677762f, -1.7669280217e-3f, 7.9027635693e-5f };
  static float b[9] = { 1.f, 0.67641463495f, 0.32773507466f,
			0.10279994528f, 0.027018504538f, 5.1647208257e-3f,
			8.7521995448e-4f, 9.5129148083e-5f, 9.986289241e-6f };

  /* Builtin functions */
  void c_div(complex *, complex *, complex *);

  complex p, q, q2;
  int i;

  /* z = gamma(x) for 0 <= x(real) <= 1, 0 <= x(imag) <= 1.
     using pade-power approximation of 1 / gamma(x) */

  p.r = a[8], p.i = 0.f;
  q.r = b[8], q.i = 0.f;
  for (i = 7; i >= 0; i--) {
    q2.r = p.r * x->r - p.i * x->i, q2.i = p.r * x->i + p.i * x->r;
    p.r = q2.r + a[i], p.i = q2.i;
    q2.r = q.r * x->r - q.i * x->i, q2.i = q.r * x->i + q.i * x->r;
    q.r = q2.r + b[i], q.i = q2.i;
  }

  c_div(ret_val, &q, &p);
  return ;
} /* gam2 */

void hyperg(complex *ret_val, complex *a, complex *b, complex *x)
{
  /* Initialized data */
  static float prec = 1.0e-6f;

  /* Builtin functions */
  void c_div(complex *, complex *, complex *);
  double c_abs(complex *);

  complex q1, q2, q3, q4, test, t, fn, apn, bpn;
  int n;

  /* z = hypergeometric(a, b, x).
     dummy arguments:
     a,b,x single precision complex input values
     adopted from 1604 subroutine of c.w. nestor. */

  apn.r = a->r, apn.i = a->i;
  bpn.r = b->r, bpn.i = b->i;
  fn.r = 0.f, fn.i = 0.f;
  t.r = 1.f, t.i = 0.f;
  ret_val->r = 1.f,  ret_val->i = 0.f;

  for (n = 1; n <= 30; ++n) {
    q1.r = fn.r + 1.f, q1.i = fn.i;
    fn.r = q1.r, fn.i = q1.i;
    q4.r = t.r * apn.r - t.i * apn.i, q4.i = t.r * apn.i + t.i * apn.r;
    q3.r = q4.r * x->r - q4.i * x->i, q3.i = q4.r * x->i + q4.i * x->r;
    c_div(&q2, &q3, &fn);
    c_div(&q1, &q2, &bpn);
    t.r = q1.r, t.i = q1.i;
    q1.r = apn.r + 1.f, q1.i = apn.i;
    apn.r = q1.r, apn.i = q1.i;
    q1.r = bpn.r + 1.f, q1.i = bpn.i;
    bpn.r = q1.r, bpn.i = q1.i;
    c_div(&q1, &t,  ret_val);
    test.r = q1.r, test.i = q1.i;
    q1.r =  ret_val->r + t.r, q1.i =  ret_val->i + t.i;
    ret_val->r = q1.r,  ret_val->i = q1.i;
    if (c_abs(&test) < prec) return;
  }
  printf("  ******** ERROR IN HYPERG\n"
	 "     (%20.10e, %20.10e)\n"
	 "     (%20.10e, %20.10e)\n"
	 "     (%20.10e, %20.10e)\n"
	 "     (%20.10e, %20.10e)\n%10d\n",
	 a->r, a->i, b->r, b->i, x->r, x->i, ret_val->r, ret_val->i, n);
  ret_val->r = 0.f,  ret_val->i = 0.f;
  return;
} /* hyperg */

